unit bas;

(* ver 4.36  20.jul.1992,93,95,97 *)

interface

uses dos,crt;

var com1,com2,
    lpt1,lpt2,
    lpt3,pio :word;

    csr_a,
    csr_e,
    csr_anf,
    csr_end    :byte;

    screen_zaehler:byte;

var video:word;
var vmod,rueckkehrpuffer :string;
var maus:boolean;

type return =
     record
	   zahl    : BYTE;
	   str     : array[1..40]  of string;
     end;

var  ausgabe : return;

const  zero:byte = 0;
var      nl:string[2]; (* Neue Zeile *)
const  cr:char = #13;
const  lf:char = #10;
const  esc:char = #27;
const  ret:char = #13;



function mouse:boolean;           (* mouse = false keine Maus *)
function mousex:integer;          (* x-ordinate des Cursors *)
function mousey:integer;          (* Y-ordinate des Cursors *)
function relx:longint;
function relY:longint;
function key:integer;
function replace( eingabe,such,ersatz:string):string;
function attrib( zahl:byte):string;
function upper( ein:string):string;
function left( eingabe :string;pos:integer):string;
function len(eingabe:string):real;
function right( eingabe:string;pos:integer):string;
function mid( eingabe:string;posb,pose:integer):string;
function valu(eingabe:string):real;
function spc(e:integer):string;
function strin(n:integer;zeichen:string):string;
function space(e:integer):string;
function vmode:string;
function voffs:word;
function dchar( x,y:integer):byte;
function mreadkey:char;
function SepPath( path:string):string;
function exist( such:string):boolean;
function fdir( pfad,such:string):string;
function sdir( such:string):string;
function pop(x,y:byte;titel,uebergabe:string):byte;
function roll(uebergabe:string):byte;       (* & vor dem eintrag markiert die Schlsseltaste *)
function hex(x:longint;laenge:byte):string;
function dez(eing:string):byte;             (* 8 bit binr zu Dezimal *)
function bin(eing:byte):string;             (* 8 BIT dezimal zu binr *)
function zeit_str(ut:real):string;          (* Dezimalzahl in Zeit umwandeln *)
function akt_zeit:real;                     (* Akt. Syst. Zeit *)
function strg(eing:longint):string;
function MCB_info(such:string):byte;        (* Testet, ob ein Programm im Speicher ist *)


procedure CSR_on;
procedure CSR_off;


procedure jumbo_char(ZEI:byte);
procedure jumbo_string(kette:string);
procedure mouseon;               (* MausCursor einschalten *)
procedure mset(x,y:integer); (*setzt Mauszeiger auf eine best. Position *)
procedure mouseoff;              (* Cursor ausschalten *)
procedure defcurs;               (* Mauscursor definieren *)
procedure save(xp,yp :integer); (* sichert die Mausposition *)
procedure hardcurs;

procedure setch( x,y:integer;ch:byte);

procedure setvattr( x,y:integer;ch:byte);
procedure setattr(attrib,para:string);   (* aufruf setattr(Datei,Atributtstring *)
					 (* Attributtbsp. '+r/o -h +a' *)
procedure unstring(eingang,seperator:string);
procedure fenster(xx,yy,x1,y2:integer;headline:string);
procedure ReverseVideo;

implementation


function strg(eing:longint):string;
(* int Zahl in String umwandeln *)
var    p   :string;
begin
      str(eing,p);
      strg:=p;
end;

function akt_zeit:real;

(* Gibt die Akt. Systemzeit zurck *)
var  a,b,c,d :word;
begin
     gettime(a,b,c,d);
     akt_zeit:=a+b/60;
end;
function zeit_str(ut:real):string;
var   h,m:integer;
      stri,
      hs,
      ms:string;
      nd:char;
begin
     stri:='';
     nd:=' ';   hs:='--'; ms:='--';
     if ut < 90
     then
       begin
            ut:=trunc(ut*60+0.5)/60;
            h:=trunc(ut);
            m:=trunc(60.0*(ut-h)+0.5);
            str(h mod 24:2,hs);
            str(m:2,ms);
            if ms[1] in ['1'..'9'] then else ms[1]:='0';
       end;
     zeit_str:=nd+' '+hs+':'+ms+'  ';
end;


procedure CSR_on;
var reg:registers;
begin

     asm
        mov ah,1
        mov ch,csr_a
        mov cl,csr_e
        int $10
     end;

end;

procedure CSR_off;
var reg:registers;
begin
     csr_e:=csr_end;
     csr_a:=csr_anf;
    
     asm
         mov ah,1
         mov ch,255
         mov cl,1
         int $10
     end;

end;

procedure jumbo_char(ZEI:byte);

type zeichen = array[0..2500] of byte;
var  test :word;
var  zztop:^zeichen;    (* ptr_v._typ-Zeichen *)

     bin:string[8];
     n,
     t,
     x,
     i,
     cx,
     cy:byte;

begin
            zztop:=ptr($f000,$FA6E); (* adresse der ZZTOP auf Zeichentabelle *)
            cx:=wherex;              (* Alte Cursorposition sichern *)
            cy:=wherey;

            for i:=0 to 7
            do
             begin
              bin:='       ';
              t:=1;
              x:=zztop^[zei shl 3+i];
              for n:=0 to 7             (* Wert x in eine Binrwert umwandeln *)
               do
                  begin
                       if (t and x) = t (* AND verknpfung positiv = Log _1_ *)
                           then
                               bin[8-n]:=#219;
                               t:=t shl 1;
                  end;
                  gotoxy(cx,cy+i); write(bin);
             end;
             gotoxy(cx+8,cy);           (* Cursor anpassen *)
end;

procedure jumbo_string(kette:string);
var  i:byte;
begin
      for i:=1 to ord(kette[0])        (* [0] gibt die Lnge des Strings an *)
         do
            jumbo_char(ord(kette[i]));
end;




procedure ReverseVideo;
begin
	     Textcolor(0); textBackGround(7);
end;

function mouse:boolean;      (* mouse = false keine Maus *)
var reg: registers;
begin
    mouse:=false;
    reg.ax:=$0; intr($33,reg);
    if reg.ax <> 0 then
		   mouse:=true;
end;

procedure mouseon;               (* Cursor einschalten *)
var reg: registers;
begin
    if maus = true
    then
      begin
        reg.ax:=$0001; intr($33,reg);
      end;
end;

procedure mset( x,y:integer); (*setzt Mauszeiger auf eine best. Position *)
var reg: registers;
begin
     if maus = true
     then
       begin
            reg.ax:=$0004;  reg.cx:=x;  reg.dx:=y;
            intr($33,reg);
       end;
end;

procedure mouseoff;               (* Cursor ausschalten *)
var reg: registers;
begin
    if maus = true
    then
     begin
      reg.ax:=$0000; intr($33,reg);
     end;
end;

function mousex:integer;
var reg: registers;               (* X-ordinate des Cursors *)
begin
    mousex:=1000;
    if maus = true
    then
    begin
     reg.ax:= $03; intr($33,reg);
     mousex:=reg.cx;
    end;
end;

function mousey:integer;          (* Y-ordinate des Cursors *)
var reg: registers;
begin
     mousey:=1000;
     if maus = true
     then
      begin
           reg.ax:= $03;  intr($33,reg);
           mousey:=reg.dx;
      end;
end;

function relX:longint;
var reg: registers;
begin
     reg.ax:= $000B; intr($33,reg);
     relx:=reg.cx;
end;

function relY:longint;
var reg: registers;
begin
     reg.ax:= $000B; intr($33,reg);
     rely:=reg.dx;
end;

procedure defcurs;               (* Mauscursor definieren *)
const mcurs :array[0..31] of word =
      ($e007,$c001,$8001,$83c1,$8181,$8001,$8811,$8c31,
       $8811,$8001,$8181,$83c1,$8001,$c003,$e007,$ffff,

       $0000,$1ff8,$300c,$381c,$2c34,$2664,$23c4,$2184,
       $23c4,$2664,$2c34,$381c,$300c,$1ff8,$0000,$0000);

var reg: registers;
begin
     mouseon;
     reg.ax:= $0009; reg.es:= seg(mcurs); reg.dx:= ofs(mcurs)+1;
     reg.bx:= 8;     reg.cx:= 8;          intr($33,reg);
     mouseoff;
end;


function key:integer;
var reg: registers;                (* Maustasten abfragen *)
begin
     key:=0;
     if maus = true
     then
     begin
        reg.ax:= $03; intr($33,reg);
						(* key = 1 : taste = links *)
        key:=reg.bl;                            (* key = 2 : taste = rechts *)
						(* key = 3 : beide tasten *)
     end;
end;

procedure save( xp,yp :integer); (* sichert die Mausposition *)

begin
     if maus = true
     then
      begin
           xp:=mousex; yp:=mousey;
      end;
end;

procedure hardcurs;
var reg: registers;    (* *)
begin
      reg.bl:=1; reg.ax:=$0a; intr($33,reg);
end;

function replace( eingabe,such,ersatz:string):string;
var i :byte;
var lp:string;

begin
      lp:='';

      while pos(such,eingabe) > 0
       DO begin

	     i:=pos(such,eingabe);
	     lp:=lp+copy(eingabe,1,i-1)+ersatz;

	     delete(eingabe,1,i+length(such)-1);
      end;

      replace:=lp+eingabe;

end;

procedure setattr(attrib,para:string);   (* aufruf setattr(Datei,Atributtstring *)
					 (* Attributtbsp. '+r/o -h +a' *)
var puffer,
     datei  :file;
     vatt,
     tattr,
     neuattr,
     resattr:word;


begin
       assign(datei,attrib);
       getFattr(datei,vatt);
       neuattr:=0;
       tattr:=0;

       if pos('+R/O',para) > 0
	  then
	      neuattr:=neuattr+readonly;
       if pos('-R/O',para) > 0
	  then
	      tattr:=tattr+readonly;


       if pos('+H',para) > 0
	  then
	      neuattr:=neuattr+hidden;
       if pos('-H',para) > 0
	  then
	      tattr:=tattr+hidden;


       if pos('+D',para) > 0
	  then
	      neuattr:=neuattr+directory;
	if pos('-D',para) > 0
	  then
	      tattr:=tattr+directory;


       if pos('+A',para) > 0
	  then
	      neuattr:=neuattr+Archive;
	if pos('-a',para) > 0
	  then
	      tattr:=tattr+archive;

       if pos('+S',para) > 0
	  then
	      neuattr:=neuattr+sysfile;
	if pos('-S',para) > 0
	  then
	      tattr:=tattr+sysfile;

       resattr:=neuattr or vatt;
       resattr:=resattr and not tattr ;

       setFattr(datei,resattr);

end;

function bin(eing:byte):string;

var n:byte;

begin
         bin:='00000000';

         for n:=0 to 7             (* Wert x in eine Binrwert umwandeln *)
               do
                  begin
                       if (eing shr n and 1) = 1 (* AND verknpfung positiv = Log _1_ *)
                           then
                               bin[8-n]:='1';
                  end;

end;

function dez(eing:string):byte;

var i,z:byte;

begin
      z:=0;
      for i:=7 downto 0
        do
          if eing[8-i]='1'
                          then  z:=z+1 shl i;
      dez:=z;


end;

function  attrib(zahl:byte):string;            (* attributwert in String umwandeln *)
var puffer :string;
begin
	puffer:='';
	if zahl and hidden = hidden
	   then
	       puffer:='h'
	   else
	       puffer:='-';

	if zahl and readonly = readonly
	   then
	       puffer:=puffer+'r-'
	   else
	       puffer:=puffer+'rw';

	if zahl and sysfile = sysfile
	   then
	       puffer:=puffer+'s'
	   else
	       puffer:=puffer+'-';

	 if zahl and archive = archive
	   then
	       puffer:=puffer+'a'
	   else
	       puffer:=puffer+'-';

	attrib:=puffer;

end;

function upper( ein:string):string;    (* Alle Buchstaben in Groschrift wandeln *)
var i :byte;
puffer:string;

begin
      puffer:='';

      for i:=1 to length(ein)
	 do
	    puffer:=puffer+upcase(ein[i]);

      upper:=puffer;
end;

function dchar( x,y:integer):byte;
begin
      dchar:=mem[voffs:(x-1) shl 1+(y-1)*160];
end;

function hex(x:longint;laenge:byte):string;
(* Wandelt eine Zahl in einen HEX-String um
    x = Wert   laenge = lnge des Ausgabestrings *)

const kette :string[16]  = '0123456789abcdef';
var   i          :byte;
      puffer,pp  :string;
begin
       puffer:='';
       for i:=1 to laenge -1
	 do
	    puffer:=puffer+'0';

       puffer:=puffer+'0';

       for i:=1 to laenge
	  do
	   begin
	      if x > 0
		 then
		   begin
			puffer[laenge-i+1]:=kette[1+x - (x shr 4) shl 4];
			x:= x shr 4;
		   end;
	   end;
	hex:=puffer;
end;




function vmode:string;
begin
      if (mem[$40:$49] = 7) or (mem[$40:$49] = 8)
	 then
	     vmode:='bw'
	 else
	    vmode :='color';
end;

function voffs:word;
var a:byte;
begin
      a:=mem[$40:$49];
      voffs:=$b800;
      if (a > 6)
	then voffs:=$b000
	else
	    if(a > 8)
	      then voffs:=$A000;
end;


function left( eingabe :string;pos:integer):string;

begin
       left:=copy(eingabe,1,pos);
end;

function right( eingabe:string;pos:integer):string;
var i :integer;

begin
	i:=length(eingabe);
	right:=copy(eingabe,i-pos+1,i);

end;

function mid( eingabe:string;posb,pose:integer):string;

begin
       mid:=copy(eingabe,posb,posb+pose-2);
end;

function len(eingabe:string):real;

begin
       len:=length(eingabe);
end;

function valu(eingabe:string):real;

var zahl:real;
var code:integer;
begin

      val(eingabe,zahl,code);
      valu:=zahl;
end;

function space(e:integer):string;        (* erzeugt eine anzahl von Lerzeichen *)
var i:integer;
var st:string;

begin
	st:='';
	for i:=1 to e
	    do
	       st:=st+' ';

	space:=st;
end;

function spc(e:integer):string;

begin
       spc:=space(e);
end;

function strin(n:integer;zeichen:string):string;
var t:string;
var i:integer;

begin
      t:='';
      for  i:=1 to n
	  do
	     t:=t+zeichen;
      strin:=t;
end;

function mreadkey:char;     (* Tastensimulation  mit der Maus  Ersatz fr readkey *)
VAR taste:char;
var mx,my:integer;

begin;
  repeat
	     begin
		 taste:=#0;
		 if keypressed then
				 taste:=readkey;

		  if maus = true then                (* simulation der Tastatureingabe mit der Maus *)
		  begin
			 mx:=mousex shr 3 +1;
			 My:=mousey shr 3+1;

			 if key = 1 then             (* weist bei Mausklick den Bildschirm-
							wert der Taste zu *)
			    begin
			      taste:=chr(dchar(mx,my));
			      delay(100);
			    end;

			 if key = 2                  (* Maustaste = RETURN *)
			    then taste:=#13;

			 if key = 3 then             (* beide Maustasten = ESC *)
			    begin
			      taste:=#27;
			      delay(250);
			    end;

			 if taste = #30 then         (* chr(13) auf dem Bildschirm
						      wird beim anwhlen zu CSR-DOWN *)
			       taste:='H';
			 if taste = #31 then
			       taste:='P';
		   end;
	     end;
  until(taste <> #0);
  mreadkey:=taste;
end;

function SepPath( path:string):string;          (* Gibt den Pfad mit Laufwerk zurck *)
var pfad : string;                              (* Achtung der Pfad wird von der *)
						(* EINGANGSVARIABLE abgetrennt   *)
begin                                           (* xx:=SetPath(nn) nn = Pfad *);
	pfad:='';				(* nn = Dateiname *)
	if path[2] <> ':'
	   then
	      begin
		 getdir(0,pfad);
		 pfad:=left(pfad,2);
	      end;
    repeat
	   pfad:=pfad+left(path,pos('\',path));   (* Pfad - Trennen *)
	   delete(path,1,pos('\',path));
    until (pos('\',path) = 0);

    seppath:=pfad;
    (*
    writeln(pfad);
    e_tast;
    *)
end;

function exist( such:string):boolean;      (* testet, ob eine Datei vorhanden ist *)
var eintrag:searchrec;
var datei,buffer:string;


begin
      findfirst(such,anyfile,eintrag);
      exist:=false;
      if doserror = 0
       then  EXIST:=true;
end;

function fdir( pfad,such:string):string;   (* such pfad / typ dateiart *)
var dat,x,y,xa,ya,off,
    aus,i,xii,xaa,xbb   :byte;
var xx,yy,x1		:integer;
    e_file        	:array [0..100] of string[12];
    e_size              :array [0..100] of longint;
    e_attr		:array [0..100] of byte;
    eintrag		:searchrec;
    datei,buffer,extens	:string;
    spa			:string;
    taste  		:char;

begin
	 if (right(pfad,1) <> '\') and (len(pfad) > 0)
	 then pfad:=pfad+'\';

      spa:='              ';
      x1:=1;   fdir:='??';
      x:=1; y:=1; xa:=x ; ya:=y; off:=1;

      findfirst(pfad+'*.',anyfile,eintrag);
      if (doserror = 0) and (eintrag.attr = $10)
       then
	  begin
	     e_file[x1]:=eintrag.name;
	     e_size[x1]:=eintrag.size;
	     e_attr[x1]:=eintrag.attr;
	 end;

      while doserror = 0
	  do
	     begin

		  eintrag.name:='';
		  findnext(eintrag);

		  if (eintrag.attr = $10)
		    then
		      begin
			 inc(x1);
			 e_file[x1]:=eintrag.name;
			 e_size[x1]:=eintrag.size;
			 e_attr[x1]:=eintrag.attr;
		      end;

	     end;

	     for xii:=1 to x1-1
	       do
		 for xaa:=1 to xii
		   do
		      begin
			    if e_file[xii] < e_file[xaa]
			       then
				 begin
				       e_file[0]:=e_File[xii];
				       e_file[xii]:=e_File[xaa];
				       e_file[xaa]:=e_File[0];
				 end;
		      end;
      xbb:=x1;

      findfirst(pfad+such,anyfile,eintrag);
      if (doserror = 0) and (eintrag.attr <> $10)
       then
	  begin
	     e_file[x1]:=eintrag.name;
	     e_size[x1]:=eintrag.size;
	     e_attr[x1]:=eintrag.attr;
	 end;

      while doserror = 0
	  do
	     begin
		  eintrag.name:='';
		  findnext(eintrag);
		   if eintrag.attr <> $10
		   then
		     begin
		       inc(x1);
		       e_file[x1]:=eintrag.name;
		       e_size[x1]:=eintrag.size;
		       e_attr[x1]:=eintrag.attr;
		     end;
	     end;

	     e_file[x1]:='??';
	     e_size[x1]:=0;
	     e_attr[x1]:=$ff;

             if x1 > 0 then
	      begin
		  GOTOxy(18,4); writeln('ͻ');
		  gotoxy(18,5); writeln(' Pfad :[',right(pfad,20),']',right(spa,23-trunc(len(pfad))));
		  gotoxy(59,5); writeln('');
		  gotoxy(18,6); writeln('Ŀ [A:] [B:] [C:] [D:] [E:]   ');
		  for i:=7 to 11 do
			begin
				gotoxy(18,I);
				writeln('                                       ');
			end;
		  gotoxy(18,12);writeln('                           ');
		  gotoxy(18,13);writeln('                                         ');
		  gotoxy(18,14);writeln('ͼ ');

		  if pfad[1] in ['A'..'E']
		  then
		    begin
			 HIGHVIDEO;
			 GOTOXY(35+(ORD(PFAD[1])-65)*5,6);
			 WRITE(LEFT(PFAD,2));
			 LOWVIDEO;
		    end;

		  xx:=33; yy:=6;
		  setch(xx,yy,30);
		  gotoxy(20,6); write('*[');
		  highvideo;
		  write(right(such,11));
		  lowvideo;
		  writeln(']');
		  gotoxy(35,11);writeln('Dateien :',x1-1:2);
		  gotoxy(35,13);writeln('Frei :',diskfree(ord(pfad[1])-64) ,' bytes');
		  yy:=12;
		  setch(xx,yy,31);
		  gotoxy(20,14); writeln('[Anwahl mit ENTER]');

		  repeat
			begin;
			      for xx:=off to 4+off do
				   begin;
                                        gotoxy(20,7+xx-off);
					if xx <= x1
					    then
					      begin
					       datei:=e_file[xx]+'          ';
					       writeln(left(datei,12))
					      end
					    else
					     writeln('            ');
				   end;
				   gotoxy(20,7);

				   fdir:=e_file[xx-4];

				   ReverseVideo;
				   writeln(e_file[xx-4]);
				   normvideo;
				   highVideo;
                                   gotoxy(35,7); writeln(attrib(e_attr[xx-4]));
				   LowVideo;
				   gotoxy(48,11);
				   writeln('Mark.:',xx-4:2);
				   gotoxy(35,12);
				   writeln('Size :',e_size[xx-4]:6,' Bytes');

				   taste:=mreadkey;

				   if taste = 'P'
				      then
					 IF off < x1
					    then
						inc(off);

				   if taste = 'Q'
				      then
					 IF off < x1-4
					    then
						off:= off + 4;

				   if taste = 'H'
				      then
					  if off > 1
					    then dec(off);

				   if taste = 'I'
				      then
					  if off > 4
					    then off:= off - 4;

				   if taste = 'G'
				      then
					   off:=1;

				   if taste = 'O'
				      then
					   off:=x1;

				   if taste = #27
				      then
				       begin
					  taste:=#13;
					  fdir:='.';
				       end;

				   if (taste = #13) and (e_file[xx-4] = '??')
				      then
					  begin
					       gotoxy(20,7);
					       write('  ');
					       gotoxy(20,7);
					       readln(e_file[xx-4]);

					       if e_file[xx-4] = ''
						 then
						     e_file[xx-4]:= '??';

					       fdir:=e_file[xx-4];
					  end;

				   if (taste = #13) and (e_attr[xx-4] = $10)
				      and (e_file[xx-4][1] <> '.')
				      then
				       begin
					  extens:=pfad+e_file[xx-4];
					  rueckkehrpuffer:=fdir(extens,such);
					  if rueckkehrpuffer[1] = '.'
					    then
						taste:=#0
					    else
						 fdir:=e_file[xx-4]+'\'+rueckkehrpuffer;
					    gotoxy(18,5);
					    writeln(' Pfad :[',right(pfad,20),']             ');
					    gotoxy(35,11);
					    writeln('Dateien :',x1-1:2);
				       end;
			end;


		   TASTE:=UPCASE(TASTE);

		   until(taste IN [#13,'A'..'F','*']);

		   IF TASTE IN ['A'..'F','*']

			 THEN
			      FDIR:=TASTE+':\';


	      end;
end;

function pop(x,y:byte;titel,uebergabe:string):byte;
var zahl,
    max,
    i,p :byte;
    key :char;
    s_key:string[40];
    s_kx:array[1..20] of byte;
begin
     max:=0;  p:=1; key:=' ';   pop:=zero;
     unstring(uebergabe,';');

     S_key:='';  for i:=1 to 20 do begin s_kx[i]:=0; s_key:=s_key+#254 ;end;

     for i:=1 to ausgabe.zahl
        do
         begin

          s_kx[i]:=pos('&',ausgabe.str[i]);  (* KEY-TASTEN FILTERN *)
          if s_kx[i] > 0
          then
             begin
              s_key[i]:=upcase(ausgabe.str[i][s_kx[i]+1]);
              delete(ausgabe.str[i],s_kx[i],1)
             end;
         end;




     for i:=1 to ausgabe.zahl
        do
         if length(ausgabe.str[i]) > max
                then
                     max:=length(ausgabe.str[i]);
     textcolor(14);
     textbackground(2);
     fenster(x,y,x+3+max,y+1+ausgabe.zahl,titel);
     textcolor(7);
     textbackground(2);
     for i:=1 to ausgabe.zahl
        do
         begin
          gotoxy(1,i);
          write(' ',ausgabe.str[i]);
         end;

     repeat

          reversevideo;
          gotoxy(2,p);
          write(copy(ausgabe.str[p]+'                            ',1,max),#13);
          key:=upcase(readkey);
          textcolor(7);
          textbackground(2);
          gotoxy(2,p);
          write(copy(ausgabe.str[p]+'                            ',1,max),#13);

          if key = 'H'
              then
                 if p > 1
                     then dec(p);
          if key = 'P'
                  then
                      if p < ausgabe.zahl
                              then
                                   inc(p);

     until(key in [#13,#27]);
     if key = #13
       then
          begin
              reverseVideo;
              gotoxy(2,p);
              write(copy(ausgabe.str[p]+'                            ',1,max),#13);
              normVideo;
              pop:=p;
          end;

    window(1,1,80,25);
end;

function roll(uebergabe:string):byte;

type scr_ = array[0..4000] of word;

var zahl,
    i,p :byte;
    rkey :char;
    le   :byte;
    pox  :array[1..20] of byte;
    S_key:string[40];
    s_Kx :array[1..20] of byte;
    altx,
    alty,
    ay,
    farbe,
    s_x,
    s_y,
    s_c :byte;
    zeit:byte;
    bild:byte;
    may :word;

    alt_zeit:real;

    screen_:^scr_;
    scr_pu_:^scr_;


begin


     bild:=pos('/#S',uebergabe);    (* Bildschirm_schoner *)
     if  bild > 0
     then
        begin
         delete(uebergabe,bild,3);
        end;

     zeit:=pos('/#T',uebergabe);    (* Uhr soll angezeigt werden *)
     if  zeit > 0
     then
        begin
         delete(uebergabe,zeit,3);

        end;

     video:=voffs;

     scr_pu_:=ptr(video,0);

     if bild > 0 then getmem(screen_,8000);




     csr_off;
     p:=1; rkey:=' ';   roll:=zero;

     S_key:='';  for i:=1 to 20 do begin s_kx[i]:=0; s_key:=s_key+#254 ;end;


     unstring(uebergabe,';');



     textcolor(7);
     textbackground(1);

     mouseon;
     gotoxy(1,1);

     for i:=1 to ausgabe.zahl
        do
         begin
          pox[i]:=wherex;

          s_kx[i]:=pos('&',ausgabe.str[i]);  (* KEY-TASTEN FILTERN *)
          if s_kx[i] > 0
          then
             begin
              s_key[i]:=upcase(ausgabe.str[i][s_kx[i]+1]);
              delete(ausgabe.str[i],s_kx[i],1)

             end;

          write(ausgabe.str[i],' ');


         end;
         gotoxy(1,1);


     ay:=wherey-1;

     repeat
          for i:=1 to ausgabe.zahl
          do
          if s_key[i] < #244 then
           begin
                gotoxy(pox[i]+s_kx[i]-1,1);
                textcolor(yellow);
                write(s_key[i]);
                textcolor(7);
           end;

          reversevideo;
          gotoxy(pox[p],1);
          write(ausgabe.str[p]);

          if s_key[P] < #244 then
           begin
                gotoxy(pox[P]+s_kx[P]-1,1);
                textcolor(yellow);
                write(s_key[P]);
                textcolor(7);
           end;
          
     

          le:=length(ausgabe.str[p])-1;

          alt_zeit:=akt_zeit;

          may:=mousey;

          repeat
                case key
                of
                 1:rkey:=#13;
                end;


                 if bild > 0 then if frac(abs(akt_zeit-alt_zeit))*60  > screen_zaehler
                                          then
                                              begin
                                                   if Bild <> 200
                                                      then
                                                          begin
                                                            bild:=200;
                                                            mouseoff;
                                                            move(scr_pu_^,screen_^,8000);
                                                          end;

                                                          if mousey <> may
                                                            then
                                                                mset(mousex,5);

                                                            farbe:=random(15);
                                                            s_y:=random(13);
                                                            s_x:=random(41);

                                                            setvattr(s_x,s_y,farbe);
                                                            setvattr(80-s_x,s_y,farbe);
                                                            setvattr(80-s_x,25-s_y,farbe);
                                                            setvattr(s_x,25-s_y,farbe);
                                                            textcolor(15);
                                                            gotoxy(32,12);write('>>>> PAUSE <<<<');
                                              end;



                if Zeit > 0 then begin textcolor(0);gotoxy(70,24);write(zeit_str(akt_zeit));end;



          until keypressed or ((((rkey in[#13,#27]) or ((1+mousex div 8) < pox[p])
                           or ((mousex div 8) > pox[p]+le)) and (mousey div 8 = ay)) and maus = true);


          if bild = 200
               then
                  begin
                       bild:=1;
                       move(screen_^,scr_pu_^,8000);
                       mouseon;
                  end;

          if keypressed
          then
            begin
              rkey:=upcase(readkey);
              if rkey = #0           (* Erweiterte tastaturcodes *)
                then
                  begin
                   rkey:=readkey;
                   case rkey
                   of
                     'K':rkey:=#203;
                     'M':rkey:=#205;
                   else
                     rkey:=#244;
                  end;
                end;

              mset((pox[p] * 8)+1,10);
            end;

          if maus  
          then
            begin
                 if (1+mousex div 8) < pox[p]
                 then
                     rkey:=#203;   (* 75 + 128 *)

                 if (mousex div 8) > pox[p]+le
                 then
                     rkey:=#205;   (* 77 +128  *)
            end;



          textcolor(7);
          textbackground(1);

          gotoxy(pox[p],1);
          write(ausgabe.str[p]);

          if rkey = #203
          then
          if p > 1
             then dec(p);

          if rkey = #205
          then
             if p < ausgabe.zahl
                              then
                                   inc(p);


          if pos(rkey,s_key) > 0
            then
                begin
                      p:=pos(rkey,s_key);
                      rkey:=#13;
                end;

     until(rkey in [#13,#27]);

     if rkey = #13
       then
          begin
              reverseVideo;
              gotoxy(pox[p],1);
              write(ausgabe.str[p]);
              normVideo;
              roll:=p;
          end;

    if bild > 0 then freemem(screen_,8000);
    mouseoff;
    csr_on;
end;


function sdir( such:string):string;      (* Steuerteil der Selectorbox      *)
var ret:byte;                            (* Gibt den vollstndigen Namen    *)
					 (* in der Form LW:\PFAD\DATEI.EXT  *)
var pfad,                                (* zurck.  Bei Anwahl der '??'    *)
    found,                               (* kann ein Name eingegeben werden *)
    LW    :string;                       (* Wird kein Name eigegeben, sondern *)
					 (* mit Return besttigt, so werden *)
					 (* ergibt sich der Wert:           *)
begin                                    (* LW:\PFAD\??			    *)
   such:=upper(such);                    (* Mit dem Buchstaben A-F kann ein *)
					 (* LW selectiert werden. Wobei die *)
   pfad:=SepPath(such);                  (* Suche in der Wurzel beginnt     *)

   repeat                                (* Aufruf mit : xx:=sdir(var);     *)
					 (* VAR = 'LW:\PFAD\DATEI.ERW       *)
     if such=''                          (* es knnen Alle mglichkeiten des*)
	 then such:='*.*';               (* DIR genommen werden zb: var:='*.exe'*)

     found:=fdir(pfad,such);

     if found ='*:\'
	    then
	      begin
		gotoxy(22,6);
		writeln('      ]');
		gotoxy(22,6);
		readln(such);
		such:=upper(such);
		found:='         ';
		found:='.';
	      end;

     if FOUND[2] = ':'                       (* Neues Laufwerk zuweisen *)
       then
	   begin
		pfad:=found;
		found:='.';
	   end;

     until(found <> '.');

     sdir:=PFAD+found;
end;



(* Ende der Dir proceduren *)



procedure setch( x,y:integer;ch:byte);
begin
     mem[voffs:(x-1) shl 1+(y-1)*160]:=ch;
end;

procedure setvattr( x,y:integer;ch:byte);
begin
     mem[voffs:(x-1) shl 1+(y-1)*160+1]:=ch;
end;


procedure fenster(xx,yy,x1,y2:integer;headline:string);

(*  headline:='XYZ'  Fenster ohne Schatten *)
(*  headline:='#xyz' Fenster mit  Schatten *)

var lae :integer;
var i  :integer;

const strich: string = '';

begin

      window(1,1,80,24);
      lae:=abs(x1-xx);
      gotoxy(xx,yy);writeln(left(strich,lae));
      gotoxy(xx,y2);writeln(left(strich,lae));
      gotoxy(xx+lae div 2-length(headline) div 2,yy);
      for i:=yy to y2
	do
	  begin
	       gotoxy(xx,i);writeln(#186);
	       gotoxy(x1,i);writeln(#186);
	       if headline[1]='#'
		 then
		    if x1 < 80
		       then
			  setvattr(x1+1,i+1,6);
	  end;

      if headline[1]='#'
	 then
	    if  y2 < 24
	      then
	      for i:=xx+1 to x1
		 do
		   setvattr(i,y2+1,6);

       if headline[1] = '#'
	 then
	     delete(headline,1,1);

       if headline <> ''
       then
	  begin
	       gotoxy(xx+lae div 2-length(headline) div 2,yy);
	       writeln('[',headline,']');
	  end;

      setch(xx,yy,201); setch(x1,yy,187);
      setch(xx,y2,200); setch(x1,y2,188);
      window(xx+1,yy+1,x1-1,y2-1);
      clrscr;

end;

procedure unstring( eingang,seperator:string);
var i: byte;
begin
       I:=0;
       if pos(seperator,eingang) > 0
       then
	   repeat
		   inc(i);
		   ausgabe.str[i]:=left(eingang,pos(seperator,eingang)-1);

		   if ausgabe.str[i] = ''
		      then dec(i);

		   delete(eingang,1,pos(seperator,eingang));

	   until (pos(seperator,eingang) = 0);

	   inc(i);
	   ausgabe.str[i]:=eingang;
	   ausgabe.zahl:=i;
end;

(* ------------------------------------- *)


function MCB_info(such:string):byte;


type MCB1  = record
                  ID   :char;
                  PSP  :word;
                  PARA :word;  (* x16 = bytes *)
                (*   res  :array[1..3] of byte;
                  Ownwr:array[1..8] of char; *)
                  filler:string;
            end;

type PSP1  = record
              fill: array[0..$80] of byte;
              param:string[20];
             end;

var reg:registers;

var MCB:^mcb1;


type ptra = record
             offs:word;
             segm:word;
          end;

var akt_MCB :pointer;
var DIP     :^ptra;
var anz_para:^PSP1;
    test    :pointer;
    fehler  :byte;


procedure mcb_write(eing:pointer);
var i:byte;
    kette:string;

begin
     mcb:=eing;
     kette:='';
     write(hex(seg(eing^),4),'| ',mcb^.para shl 4 :5,'  ');

     if mcb^.psp = 8
        then
           write('DOS')
        else
           if mcb^.psp = 0
               then
                   write('Frei ')
               else
        begin
         for i:=3 to 10
         do
           if mcb^.filler[i] in ['A'..'Z','0'..'9','_','+','.','=']
            then
               kette:=kette+mcb^.filler[i]
            else
               kette:=kette+' ';

         write(kette);
         if pos(such,kette) > 0
         then
             MCB_INFO:=1;

        anz_para:=ptr(mcb^.psp,0);

        write('  ');

        if anz_para^.fill[$80] < 20
        then
           for i:=1 to anz_para^.fill[$80]
            do
               write(anz_para^.param[i]);
        end;

      gotoxy(40,wherey);
      write(' :');

      if such = ''
      then
      for i:=0 to $7F
       do
         begin
               swapVectors;          (* TP-Vectoren ausblenden *)
               getintvec(i,test);
               swapVectors;          (*  Einblenden *)

               if ((seg(test^) > seg(mcb^)) and (seg(test^) <= seg(mcb^)+mcb^.para+1))
                  then
                            write(hex(i,3));
         end;

      writeln('');
end;

begin
     MCB_info:=0;
     if such = ''
     then
         writeln('Segm   Gre    Name     Parameter            IR-Vectoren ')
     else
         writeln('Segm   Gre    Name     Parameter    ');

     reg.ah:=$52;
     intr($21,reg); (* Liefert einen Pointer auf den DIB *)
     dip:=ptr(reg.ES,reg.BX-4);

     akt_mcb:=ptr(dip^.segm,dip^.offs);

     mcb_write(akt_mcb);
     mcb:=akt_Mcb;

     (*Next_mcb*)

     while mcb^.id = 'M'
       do
         begin
                 mcb:=ptr(seg(akt_mcb^) + mcb^.para + 1,0);
                 akt_mcb:=mcb;
                 mcb_write(akt_mcb);
         end;


end;



begin
      screen_zaehler:=1;      (* Bildschirmschoner bei ROLL auf 3 Minuten *)
      nl:=#10+#13;
      video:=voffs;           (* Offsetadresse des Videospeichers *)
      vmod:=vmode;            (* bw = Schwarz/wei  color = Farbe *)
      maus:=mouse;            (* Maus vorhanden ? *)
      maus:=mouse;

		COM1:=memw[$0000:$400];    (* Belegung mit den Basisadressen *)
		com2:=memw[$0000:$402];    (* der Schnittstellen *)
		LPT1:=memw[$0000:$408];
		LPT2:=memw[$0000:$40A];
		LPT3:=memw[$0000:$40C];
		PIO:=memw[$0000:$40E];
      csr_end:=1;
      csr_anf:=2;
end.

(*
   rueckkehrpuffer = Globale Variable fr Sdir, damit das Program bei
   Recursionen zurckfindet !.

   Achtung: alle Stringfunktionen sollten ber eine Puffervariable
	    benutzt werden ...

   Video = Globale variable, in der die Offsetadresse des Bildschirmes
   steht !
   Vmode =  "         "    , die angibt, ob S/W oder Farbe
   UNSTRING   zerschneidet eine STRINGKETTE;

     Unstring(eingang[string],seperator[string]);

     ausgabe in die variable AUSGABE vom TYP RECORD !!
	     Ausgabe.zahl = Anzahl der Stringteile
	     Ausgabe.str[n] = einzelnes Stringteil
	     Max 40 Teile mglich (n)

   Replace    sucht und ersetzt Zeichen bzw. Zeichenketten
      Variable:=replace(eingabestring,suchstring,ersatzstring);

   bei Mausabfrage: als erstes eine Variable belegen vom typ BOOLEAN
   und mit "MOUSE" belegen und diese als Abfrage benutzen,
   ob eine Maus vorhanden ist.
   (der Aufruf MOUSE stellt den Cursor sonst auf Bilsdchirmmitte
*)

