unit MZIO;

interface

uses bas,crt,dos(*,sb*),uz80,kbd,z80das,fenst;



type     memory = array[0..$FFFF-1] of Byte;
         einsam = array[0..12]      of byte;
         PByteArray = ^memory;
         Peinsam    = ^einsam;

         ti_    = byte;
         wpt    = word;

         screen320 = array[0..319,0..199] of byte;

         V320screen = ^screen320;

         (* MZ700 Speicher    (MZ80K nur BANK 0)

                      BANK 0               / BANK 1

            0000 - 0FFF ROM                / RAM
            1000 - 1FFF RAM                / CGROM
            C000 - CFFF RAM                / CGRAM
            D000 - D3E7 VIDEORAM sichtb    / RAM
            D3E8 - D7FF Videoram unsichtb  / RAM
            D800 - DBE7 Farbram  sichtb    / RAM
            DBE8 - DFFF Farbram  unsichtb  / RAM
            E000 - FFFF E/A Bereich        / RAM

         *)

         (* MZ1500 *)

         (* Die Zeichenstze knnen im Speicher verschoben werden !!!

            A000        Zeichengenerator 1   im RAM !!!!!
            B000              ""         2     ""
            C000              ""         3     ""
            D400 - D917  2.ter Bildschirm berlagert den ersten

         *)

(*
const  mz_to_vga: array[0..8] of byte = (0,1,4,5,2,3,11,15,15);
*)
const  mz_to_vga: array[0..8] of byte = (0,1,2,3,4,5,6,7,8);
       MZmode:byte = 0;

var tast:char;



var     Sys_schalter,ML_ROM,sync,V_RAM,
        CG_ROM,v_contr_A,frame,enable_bank,
        MH_rom,G_ROM:byte;   (* Bankswitch *)

        DATEINAME,
        akt_dir:string;

        last_key:word;
        key_flag,
        lade_flag,
        scroll,
        scrollalt,
        (* no_reset, *)
        sound_enable,

        out_2,
        out_3,
        out_4,
        debug,
        alt_out4 :byte;
        i_period :word;

        tapetik  :byte;
        tapefile,
        mzprint  :file of byte;


        scount,
        scr_b_seg:word;
        debug_crt:word;

        MZ_1500_mode,MZ_800_mode,
        CPU_speed:byte;

        gef:win;


var    keyports:  array[0..16] of byte;
       pb_select: byte;

       mousep_x,     (* MAUS POSITION *)
       mousep_y,
       mouseA_y,
       mouseA_x :word;

     (* -------------------- *)
     dasam      :byte;
     r_anz_:byte;
     modus:byte;
     eing:string;
     code:integer;

     speicher : PbyteArray;
     einsam1  : Peinsam;
     ROM      : pbytearray;
     einsam2  : peinsam;

     exit_run : byte;

     Maschine :byte;


     (* -------------------------- *)

     aZ80Regs: ^TZ80ASMRegs;

     MODE13_screen:^screen320;

     (* -------------------------- *)

     INIT_CRT:procedure;
     put_patt_8_MZ700:procedure(x,y:word;farbev,farbeh:byte;A_s,A_o:word);
     put_patt_8_MZ1500:procedure(x,y:word;farbev,farbeh:byte;A_s,A_o:word;Flag:byte);
     procedure put_patt_MZ80(x,y:word;farbev,farbeh:byte;A_s,A_o:word);
     procedure set_mode_Q(name:string);

(* --------------------------- *)


procedure wart;
procedure help(eing:string);
procedure fehler_MZ700_anzeige;
procedure copr_anzeige(ver,DATUM:string);

procedure SetDAC(DAC, R, G, B : Byte);
procedure init_mode_13;
procedure init_mode_640;
procedure init_text;

procedure beep;


procedure put_patt_8(x,y:word;farbev,farbeh:byte;A_s,A_o:word);
procedure put_patt_zx(x,y:word;farbev,farbeh:byte;A_s,A_o:word);
procedure put_patt_8sw(x,y:word;farbev,farbeh:byte;adresse:pointer);
procedure put_patt_15_trans(x,y:word;farbev,farbeh:byte;A_s,A_o:word;Flag:byte);
procedure setpixel(x,y:word;c:byte);


procedure sharp700_screen(addr:word);
procedure sharp1500_screen(staddr,addr:word);
procedure refresh_1500;
procedure sharp_farbram(addr:word);
procedure refresh_crt;
procedure lese_kbd;

procedure save_MZ7(name:string;start,ende:word);
procedure save_ram(name:string;start,ende:word);
procedure save_rom(name:string;start,ende:word);
procedure load_MZ7(name:string);
procedure loadrom(name:string;start:word;dest:pointer);

procedure init_JAPAN_FNT;     (* Japanischer Zeichensatz     *)
procedure init_INTERNAT_FNT;  (* INternationaler Zeichensatz *)

function  r_word(adr:pointer):word;       (* 16 Bit speicherzugriff *)
procedure w_word(adr:pointer;eing:word);
function  EXEC_FRAGE:byte;
procedure debug_anz;

Procedure Cls (segm:word;Farbe : Byte);

implementation


(* ------------------------- TWAKE ROUTINES ----------------------- *)
(* ------------------------ (C) BY M.FRANZEN ---------------------- *)
procedure set_mode_Q(name:string);
(* NAME = ''                      : BENUTZE TWK_ARRAY  *)
(* NAME = 'xxxxx.256'             : Lade TWK-FILE      *)


(* ---- INC_FILE - erzeugt durch TWK_CNV.EXE *)


(* TWAKEFILECONVERT (C) BY M:FRANZEN 1998 *)
(* Quelldatei 256x256c.256 *)

CONST TWK_NAME ='256x256c.256';
const eintraege = $18;
const TWK_ARRY:array[0..$18] of longint =
($e30003c2,$5f0003d4,$3f0103d4,$400203d4,$820303d4,$4a0403d4,
 $9a0503d4,$230603d4,$b20703d4,$000803d4,$610903d4,$0a1003d4,
 $ac1103d4,$ff1203d4,$201303d4,$401403d4,$071503d4,$1a1603d4,
 $a31703d4,$010103c4,$0e0403c4,$400503ce,$050603ce,$411003c0,
 $001303c0);


(* --------------- *)

type REGISTER = record
	port :word;
	index:BYTE;
        value:byte;
       end;


procedure outReg(r:Register);

var x:byte;

	begin
	 case r.port
         of
	     $3c0:
                     begin
			x:=port[$3da];  		(* reset read/write flip-flop *)
			PORT[$3c0]:=r.index or $20 ;
			PORT[$3c0]:=r.value;
                      end;

	     $3c2,$3c3:
			PORT[r.port]:=r.value;	(*	directly to the port *)
	     else
                   begin 		 	(* This is the default method: *)
			PORT[r.port]:=r.index;	(*	index to port			   *)
			PORT[r.port+1]:=r.value;(*	value to port+1 		   *)
                   end;
		end;
	end;


var v:word;

    f:file of register;
    t:array[0..30] of register;
    l:byte;

    twk_conv:^register;
begin

     (* --------- LOAD MODE ------------ *)

     (*
     name:='256x256c.256';
     *)

     for v:=0 to 30 do begin t[v].port:=0;t[v].value:=0;t[v].index:=0;end;

     if name <> ''
     then
        begin

             assign(f,name);
             reset(f);
             l:=filesize(f)-1;
             writeln(l);
             for v:=0 to l
             do
               read(f,t[v]);
             close(f);

        end
      else
        begin
              for v:=0 to eintraege
              do
               begin
                   twk_conv:=@twk_arry[v];
                   t[v]:=twk_conv^;
               end;
               l:=eintraege;
               name:=twk_name;
        end;


      writeln('LADE :',name);

     (* --------- MAKE READY ----------- *)

     Asm
          mov        ax,0013h
          int        10h
     End;

     PORT[$3d4]:=$11;
     v:=port[$3d5] and $7f;
     PORT[$3d4]:=$11;
     PORT[$3d5]:=v;

     (* --------- SET REGISTER --------- *)

     for v:=0 to l
     do
        outreg(t[v]);

     (* --------- ENABLE ALL PLANES ---- *)

     portw[$3c4]:=$0f02;

     (* -------------------------------- *)
end;


Procedure Cls (segm:word;Farbe : Byte); assembler;
asm
   push    es
   mov     cx, 32767;
   mov     es,[segm]
   xor     di,di
   mov     al,[farbe]
   mov     ah,al
   rep     stosw
   pop     es
End;


procedure SetDAC(DAC, R, G, B : Byte);
begin
  Port[$3C8] := DAC;
  Port[$3C9] := R;
  Port[$3C9] := G;
  Port[$3C9] := B;
end;







procedure sharp700_screen(addr:word);

(* Addr bei $D000 *)

var  adr: word;
     x,y:word;
     i,a,farbe:byte;
     Zeichen_matrix:pointer;

begin
     adr:=addr-$D000;
     farbe:=rom^[$D800+adr];

     asm
         mov ax,adr
         shr ax,3

         cwd       (* DIV 16 BIT durch BX dazu mu mit DX erweitert *)
         mov bx,5  (* werden *)
         div bx

         shl ax,3

         push ax   (* Y ---> stapel *)

         (* ------------- nun den x - wert --------------- *)

         mov bx,5  (* 40 / 8 *)
         mul bx
         mov bx,ax
         mov ax,adr
         sub ax,bx
         shl ax,3
         mov x,ax

         pop bx    (* y <---- stapel *)
         mov y,bx

     end;

     zeichen_matrix:= @rom^[(rom^[addr] shl 3)+$C000+$800*(farbe shr 7)];

     if debug = 0
     then
       put_patt_8_MZ700(x,y,mz_to_vga[(farbe shr 4) and 7],farbe and $7,
                   seg(zeichen_matrix^),ofs(zeichen_matrix^))
       else

        put_patt_8sw(x,y,mz_to_vga[(farbe shr 4) and 7],farbe and $F,
                   @rom^[(rom^[addr] shl 3)+$C000+$800*(farbe shr 7)])
            ;

end;



procedure sharp1500_screen(staddr,addr:word);

(* Addr bei $D000 *)

var  adr: word;
     x,y:word;
     i,a,farbe:byte;

      Zeichen_matrix:pointer;

begin
     adr:=addr-staddr;

     asm
         mov ax,adr;
         shr ax,3

         cwd       (* DIV 16 BIT durch BX dazu mu mit DX erweitert *)
         mov bx,5  (* werden *)
         div bx

         shl ax,3

         push ax   (* Y ---> stapel *)

         (* ------------- nun den x - wert --------------- *)

         mov bx,5  (* 40 / 8 *)
         mul bx
         mov bx,ax
         mov ax,adr
         sub ax,bx
         shl ax,3
         mov x,ax

         pop bx    (* y <---- stapel *)
         mov y,bx

     end;

     zeichen_matrix:= @speicher^[(rom^[addr] shl 3)+$A000];

     if debug = 0
     then
          put_patt_8_MZ1500(x,y,blue,0, seg(zeichen_matrix^),ofs(zeichen_matrix^),1);



      zeichen_matrix:= @speicher^[(rom^[addr] shl 3)+$B000 ];
     if debug = 0
     then
          put_patt_8_MZ1500(x,y,brown,0,seg(zeichen_matrix^),ofs(zeichen_matrix^),1);


      zeichen_matrix:= @speicher^[(rom^[addr] shl 3)+$C000];

     if debug = 0
     then
          put_patt_8_MZ1500(x,y,yellow,0,seg(zeichen_matrix^),ofs(zeichen_matrix^),1);
     

end;


procedure refresh_1500;
var   i:word;
begin
      for i:=debug_crt+$000 to debug_crt+$3E7
             do
                sharp1500_screen(debug_crt,i);

      gotoxy(1,1);write(debug_crt);
      inc(debug_crt,$3E7);

      repeat until tastatur = [] ;
end;


procedure sharp_farbram(addr:word);

(* Addr bei $D800 *)

begin
     sharp700_screen(addr-$800);
end;

procedure refresh_crt;
var   i:word;
begin
      for i:=$D000 to $d3E7
             do
                sharp700_screen(i);
end;


procedure lese_kbd;
var y:byte;

begin

     for y:=0 to 10 do keyports[y]:=0;
     if tastaturspeicher <> []
     then
        begin
             keyports[0]:=testmem_key(KPGdn) shl 7 or testmem_key(KTilde) shl 6
                       or testmem_key(KPGUP) shl 5
                       or testmem_key(Ktab) shl 4  or testmem_key(Kquote) shl 2
                       or testmem_key(Kcolon) shl 1  or testmem_key(Kenter);

             keyports[1]:=testmem_key(Kz) shl 7 or testmem_key(Ky) shl 6
                       or testmem_key(Kequal) shl 5
                       or testmem_key(KlBracket) shl 4
                       or testmem_key(KrBracket) shl 3;

             keyports[2]:=testmem_key(Kq) shl 7 or testmem_key(Kr) shl 6
                       or testmem_key(Ks) shl 5 or testmem_key(Kt) shl 4
                       or testmem_key(Ku) shl 3 or testmem_key(Kv) shl 2
                       or testmem_key(Kw) shl 1 or testmem_key(Kx);
             keyports[3]:=testmem_key(Ki) shl 7 or testmem_key(Kj) shl 6
                       or testmem_key(Kk) shl 5 or testmem_key(Kl) shl 4
                       or testmem_key(Km) shl 3 or testmem_key(Kn) shl 2
                       or testmem_key(Ko) shl 1 or testmem_key(Kp);
             keyports[4]:=testmem_key(KA) shl 7 or testmem_key(KB) shl 6
                       or testmem_key(KC) shl 5 or testmem_key(KD) shl 4
                       or testmem_key(KE) shl 3 or testmem_key(KF) shl 2
                       or testmem_key(KG) shl 1 or testmem_key(Kh);
             keyports[5]:=testmem_key(K1) shl 7 or testmem_key(K2) shl 6
                       or testmem_key(K3) shl 5 or testmem_key(K4) shl 4
                       or testmem_key(K5) shl 3 or testmem_key(K6) shl 2
                       or testmem_key(K7) shl 1 or testmem_key(K8);
             keyports[6]:=testmem_key(Kbackslash) shl 7 or testmem_key(Kminus) shl 6
                       or testmem_key(Kslash) shl 5 or testmem_key(Kspace) shl 4
                       or testmem_key(K0) shl 3 or testmem_key(K9) shl 2
                       or testmem_key(Kcomma) shl 1 or testmem_key(Kperiod);
             keyports[7]:=testmem_key(Kins) shl 7 or testmem_key(Kback) shl 6
                       or testmem_key(Kup) shl 5 or testmem_key(Kdn) shl 4
                       or testmem_key(Krt) shl 3 or testmem_key(Klf) shl 2
                       or testmem_key(KF8) shl 1 ;

             keyports[8]:=testmem_key(KEND) shl 7 or testmem_key(Kctrl) shl 6
                       or testmem_key(Klshift);

             keyports[9]:=testmem_key(KF1) shl 7 or testmem_key(KF2) shl 6
                       or testmem_key(KF3) shl 5 or testmem_key(KF4) shl 4
                       or testmem_key(KF5) shl 3 ;
            end;
         (* if no_reset = 1 then *) for y:=0 to 9 do keyports[y]:=keyports[y] xor 255;
end;



function r_word(adr:pointer):word;
type  r_w = word;
var mem_word:^r_w;
begin
      mem_word:=adr;
      r_word:=mem_word^;
end;

procedure w_word(adr:pointer;eing:word);

type  r_w = word;
var mem_word:^r_w;
begin
      mem_word:=adr;
      mem_word^:=eing;
end;

function EXEC_FRAGE:byte;
var   c:char;
begin
      write('EXECUTE ? [Y]es / [N]');
      repeat
      until (test_key(KJ) = 1) or (test_key(KY) = 1) or (test_key(KN) = 1)
      or    (test_key(KC) = 1);

      if  (test_key(KJ) = 1) or (test_key(KY) = 1)
        then
          begin
            exec_FRAGE:=1;
           (* refresh_crt; *)
          end
       else
        if  (test_key(KC) = 1)   (* NEUE ADRESSE *)
        then
            exec_FRAGE:=2
         else
          begin
            exec_FRAGE:=0;
            write(' NO');
          end;

      writeln;
      loesche_tasten;

end;





procedure save_ram(name:string;start,ende:word);
var   i:word;
      x:byte;
  rom  :file of byte;
begin
      assign(rom,name);
      rewrite(rom);

      for i:=start to ende+1
      do
           write(rom,speicher^[i]);
      close(rom);
end;

procedure save_rom(name:string;start,ende:word);
var   i:word;
      x:byte;
  rom_  :file of byte;
begin
      assign(rom_,name);
      rewrite(rom_);

      for i:=start to ende+1
      do
           write(rom_,rom^[i]);
      close(rom_);
end;



procedure save_MZ7(name:string;start,ende:word);
var   i:word;
      x:byte;
  rom  :file of byte;
begin
      assign(rom,name+'.MZ7');
      rewrite(rom);

                     (* Speicherauszug sichern *)
      x:=lo(start);  (* Startaddr  PC *)
      write(rom,x);
      x:=hi(start);
      write(rom,x);

      for i:=start to ende+1
      do
           write(rom,speicher^[i]);
      close(rom);
end;



procedure load_MZ7(name:string);
var   n,i,z:word;
      x:byte;
      value:string;

  rom  :file of byte;
begin
    if name <> 'ESCAPE'
    then
     begin
      textcolor(14);
      assign(rom,name);
      reset(rom);

      read(rom,x);   (* erste Bytes PC *)
      i:=x;
      read(rom,x);
      i:=i+x shl 8;

      writeln('Start:',hex(i,5));

      z:=exec_frage;

      if z = 1
        then
          begin
            aZ80Regs^.pc.W:=i;
            refresh_crt;
          end;

      if z = 2
        then
          begin
              restore_keyb;
              write('New_addr :');
              readln(value);
              value:='$'+value;
              val(value,i,z);
              seek(rom,0);   (* OK kein Header *)
              neuer_tast_int;
              loesche_tasten;
          end;

      while not eof(rom)
      do
       begin
           read(rom,speicher^[i]);
           inc(i);
       end;

      close(rom);
     end;

end;




procedure loadrom(name:string;start:word;dest:pointer);
                                      (* UNIVERSAL *)
type  t = array[0..$FFFF-1] of byte;
var   p:^t;
      return:word;
      rom  :file;
begin
      {$I-}
      assign(rom,name);
      reset(rom,1);
      {$i+}

      if ioresult = 0
      then
        begin
                (* i:=start; *)
                p:=dest;
                (*
                while not eof(rom)
                do
                begin
                     read(rom,p^[i]);
                     inc(i);
                end;
                *)
                blockread(rom,p^[start],filesize(rom) and $FFFf,return);
                close(rom);
        end
            else
                 writeln('Lesefehler in :',name+'!!!');;
end;




procedure init_JAPAN_FNT;     (* Japanischer Zeichensatz     *)
var   i,x,v:word;
begin
      loadrom(akt_dir+'\mz700Fon.jap',0,@rom^[$1000]);
      move(rom^[$1000],rom^[$C000],4096);
end;

procedure init_INTERNAT_FNT;  (* INternationaler Zeichensatz *)
var   i,x,v:word;
begin
      loadrom(akt_dir+'\mz700Fon.int',0,@rom^[$1000]);
      move(rom^[$1000],rom^[$C000],4096);
end;



procedure debug_anz;
var i:word;
begin
                    gotoxy(1,23);
                      Write('AF:',Hex(aZ80Regs^.AF.W , 4),
                           ' HL:',Hex(aZ80Regs^.HL.W , 4),
                           ' DE:',hex(aZ80Regs^.DE.W , 4),
                           ' BC:',Hex(aZ80Regs^.BC.W , 4),
                           ' PC:',Hex(aZ80Regs^.PC.W , 4)+
                           ' SP:',Hex(aZ80Regs^.SP.W , 4),
                           ' IX:',Hex(aZ80Regs^.IX.W , 4),
                           ' IY:',Hex(aZ80Regs^.IY.W , 4));

                    gotoxy(1,20);
                    write('ML-ROM :',ML_ROM,'      MH-ROM :',MH_rom,'     CG-ROM :',
                          CG_rom,'    BANK_EN:',enable_bank,'   MZ800V_RAM:',V_RAM);

                    gotoxy(1,21);
                    write('$450c:',hex(speicher^[$450C],2));

                    gotoxy(60,4);
                    if aProcs[1].nIM>0 then
                    write('Interrupt mode: ',aProcs[1].nIM-1)
                    else write('Interrupt mode: 0');

                    gotoxy(60,5);write('MZmode :',mzmode);

                    gotoxy(60,1);
                    write('F3 : Normalmode');

                    (*
                    gotoxy(1,22);
                    writeln('Monitorbuffer 11A3 - 11F3 :');
                    for i:=$11A3 to $11F3
                        do
                           write(hex(speicher^[i],2),' ');
                    *)
                    gotoxy(41,1);

                    if debug > 1
                    then
                      begin
                          repeat until (tastatur =  []);
                          repeat until (tastatur <> []);
                       end;

                     if  test_key(KF3) = 1
                                then
                                    begin
                                         dasam:=0;
                                         debug:=0;
                                         loesche_tasten;
                                         if debug = 0 then init_mode_13;
                                         refresh_crt;
                                    end;



end;




(* -------------------------- Bildschirmausgabe -------------------- *)



procedure put_patt_8sw(x,y:word;farbev,farbeh:byte;adresse:pointer);

var a_o,a_s:word;
    i:byte;

    start,line:word;

begin
     a_o:=ofs(adresse^);
     A_S:=seg(adresse^);

     for i:=0 to 7
     do
        mem[$A000:x div 8 + 80*(y+i)]:=mem[a_s:a_o+i];
end;





procedure put_patt_8(x,y:word;farbev,farbeh:byte;A_s,A_o:word);


             (* AX = Y      max 200    MODE 13   Linear adreessen
                BX = X      max 320
                CL = VFARBE     256    Vordergrund
                CH = HFARBE     256    Hintergrund
                DL = MUSTER     255
                ES = SEGMENTADDR
              Gibt ein 8x8 Zeichen aus *)

begin
asm
     (* SPEICHERSTELLE *)
     mov  es,A_S
     mov  bx,a_o
     mov  ax,0

     @start_A:

         mov   dl,es:[BX]    (* erstes Byte der 8x8 Matrix *)
         push  es
         push  dx
         push  ax
         push  bx

         (* --------------------------------- *)

         add ax,y    (* bei anderer Umgebung die Register sichern *)

         mov bx,x    (* und dann Werte zuweisen *)
         add bx,1

         mov cl,farbev
         mov ch,farbeh

         push cx     (* FARBE AUF DEN STAPEL *)
         push dx

         sub bx,1
         mov cx,20   (* 320 Bildpunkte - 20  256 Farben und lineare Adressen *)
         mul cx      (* 640            - 40     *)
         mov cx,$A000(* START VGA *)
         add ax,cx    (* VERSCHIBE UM Y-ZEILEN   *)
         mov es,ax    (* bei mehr als 64 K ntig *)

         pop dx
         pop cx      (* FARBE VOM STAPEL ZURCK *)
                      (* 8 - BIT        *)
         mov dh,1    (* VERGLEICH      *)


         @START:      (* HIER DIE 8 BIT AUSGABE  *)

             test  dl,dh

             jnz @bit_0

                        mov es:[bx],ch

             jp @next

             @BIT_0:
                        mov es:[bx],cl
             @next:

             inc bx    (* X-ORDINATE um 1 erhhen *)
             shl dh,1
             cmp dh,0

         jnz @start
         (* -------------------- *)
         pop bx
         pop ax
         pop dx
         pop es

         inc bx

         inc ax
         cmp ax,8

      JNZ @START_A
   end;
end;

procedure put_patt_ZX(x,y:word;farbev,farbeh:byte;A_s,A_o:word);


             (* AX = Y      max 200    MODE 13   Linear adreessen
                BX = X      max 320
                CL = VFARBE     256    Vordergrund
                CH = HFARBE     256    Hintergrund
                DL = MUSTER     255
                ES = SEGMENTADDR
              Gibt ein 8x8 Zeichen aus *)

begin
asm
     (* SPEICHERSTELLE *)
     mov  es,A_S
     mov  bx,a_o
     mov  ax,0

     @start_A:

         mov   dl,es:[BX]    (* erstes Byte der 8x8 Matrix *)
         push  es
         push  dx
         push  ax
         push  bx

         (* --------------------------------- *)

         add ax,y    (* bei anderer Umgebung die Register sichern *)

         mov bx,x    (* und dann Werte zuweisen *)
         add bx,1

         mov cl,farbev
         mov ch,farbeh

         push cx     (* FARBE AUF DEN STAPEL *)
         push dx

         sub bx,1
         mov cx,20   (* 320 Bildpunkte - 20  256 Farben und lineare Adressen *)
         mul cx      (* 640            - 40     *)
         mov cx,$A000(* START VGA *)
         add ax,cx    (* VERSCHIBE UM Y-ZEILEN   *)
         mov es,ax    (* bei mehr als 64 K ntig *)

         pop dx
         pop cx      (* FARBE VOM STAPEL ZURCK *)
                      (* 8 - BIT        *)
         mov dh,1    (* VERGLEICH      *)


         @START:      (* HIER DIE 8 BIT AUSGABE  *)

             test  dl,dh

             jnz @bit_0

                        mov es:[bx],ch

             jp @next

             @BIT_0:
                        mov es:[bx],cl
             @next:

             dec bx    (* X-ORDINATE - 1 *)
             shl dh,1
             cmp dh,0

         jnz @start
         (* -------------------- *)
         pop bx
         pop ax
         pop dx
         pop es

         inc bx

         inc ax
         cmp ax,8

      JNZ @START_A
   end;
end;


procedure put_patt_MZ80(x,y:word;farbev,farbeh:byte;A_s,A_o:word);

begin
       put_patt_8(x,y,14,0,A_s,A_o);

end;


procedure put_patt_15_trans(x,y:word;farbev,farbeh:byte;A_s,A_o:word;Flag:byte);


             (* AX = Y      max 200    MODE 13   Linear adreessen
                BX = X      max 320
                CL = VFARBE     256    Vordergrund
                CH = HFARBE     256    Hintergrund
                DL = MUSTER     255
                ES = SEGMENTADDR
              Gibt ein 8x8 Zeichen aus *)

begin
asm
     (* SPEICHERSTELLE *)
     mov  es,A_S
     mov  bx,a_o
     mov  ax,0

     @start_A:

         mov   dl,es:[BX]    (* erstes Byte der 8x8 Matrix *)
         push  es
         push  dx
         push  ax
         push  bx

         (* --------------------------------- *)

         add ax,y    (* bei anderer Umgebung die Register sichern *)

         mov bx,x    (* und dann Werte zuweisen *)
         add bx,8
         mov cl,farbev
         mov ch,farbeh

         push cx     (* FARBE AUF DEN STAPEL *)
         push dx

         sub bx,1
         mov cx,20   (* 320 Bildpunkte - 20  256 Farben und lineare Adressen *)
         mul cx      (* 640            - 40     *)
         mov cx,$A000(* START VGA *)
         add ax,cx    (* VERSCHIBE UM Y-ZEILEN   *)
         mov es,ax    (* bei mehr als 64 K ntig *)

         pop dx
         pop cx      (* FARBE VOM STAPEL ZURCK *)
                      (* 8 - BIT        *)
         mov dh,1    (* VERGLEICH      *)


         @START:      (* HIER DIE 8 BIT AUSGABE  *)


         cmp flag,0
         jnz @Transparent



         @NO_transparent:


             test  dl,dh

             jnz @bitn_0

                       mov es:[bx],ch
             jp @next

             @BITN_0:

                        mov es:[bx],cl
             jp @next



         @TRANSPARENT:

             test  dl,dh
             mov   ch,es:[bx];
             jnz @bit_0
             jp @next
             @BIT_0:
                        or ch,cl
                        mov es:[bx],ch
             @next:

             dec bx    (* X-ORDINATE um 1 erhhen *)
             shl dh,1
             cmp dh,0

         jnz @start
         (* -------------------- *)
         pop bx
         pop ax
         pop dx
         pop es

         inc bx

         inc ax
         cmp ax,8

      JNZ @START_A
   end;
end;



procedure setpixel(x,y:word;c:byte);assembler;
asm

    mov ax,$A000;
    mov es,ax;
    mov bx,[x];
    mov AX,[Y];
    mov di,ax;
    shl di,6;
    SHL AX,8;
    add di,ax;
    add di,bx;
    mov cl,[c];
    mov byte ptr es:[di],cl
end;


procedure beep;
begin
     sound(20);nosound;
end;


(* Hier die Hardware *)



procedure init_mode_13; Assembler;
      asm
          mov ah,1;
          mov ch,$020;
          int $10;
          mov ah,0;
          mov al,$13;  (* 256 FARBEN *)
          int $10;
      end;

procedure init_mode_640;assembler;
      asm
          mov ah,1;
          mov ch,$020;
          int $10;
          mov ah,0;
          mov al,$11;
          int $10;    (* 1 Farbe *)
      end;

procedure init_text;Assembler;
      asm
          mov ah,0;
          mov al,$3;
          int $10;
          mov ah,1;
          mov cx,$0B0C;
          int $10;
      end;




procedure wart;
var    ch:char;
begin
     write('Return === > weiter');
     repeat
     until keypressed or (key = 2);
     if keypressed
     then
         ch:=readkey;
end;


(* ------------------------ HILFE fr den MZEMU  ---------------------- *)


procedure help(eing:string);

var  fe:win;

var Zeile:char;
    i    :byte;
    help_txt:text;
    str,
    ind  :string;
    ind2 :array[1..25] of string[30];


    flag,
    abbruch :byte;

    procedure read_ln;
    begin
      str:='';
      repeat
                 read(help_txt,zeile);
                 str:=str+zeile;
      until (zeile = #13) or eof(help_txt);
    end;

    procedure alt_write(eing:string);
    var i:byte;
    begin
         for i:=1 to ord(eing[0])
         do
          begin

           case eing[i] of
                '{':textcolor(15);
                '}':textcolor(7);
                '[':begin textcolor(0);textbackground(15) end;
                ']':begin textcolor(7);textbackground(blue) end;
                '&':;
             else
              write(eing[i]);
           end;
          end;
    end;

begin

  abbruch:=0;
  repeat
     fe.fenster(1,1,79,23,'#HILFE ');
     assign(help_txt,eing);
     reset(help_txt);

     (* INDEXTABELLE AUFBAUEN *)

     ind:='';    i:=0;

     while not eof(help_txt)
     do
      begin
            str:='';
            repeat
                 read(help_txt,zeile);
                              (* < INDEX BEGIN *)
            until (zeile = '<') or eof(help_txt);
            read(help_txt,zeile);

            repeat
                  str:=str+zeile;
                  read(help_txt,zeile);
            until (zeile = '>') or eof(help_txt);

            if str <> 'END'
            then
              begin
               inc(i);
               ind2[i]:='<'+str+'>';
               ind:=ind+str+';';
              end;
      end;

     ind[ord(ind[0])]:=' ';
     close(help_txt);


     fe.deselect;
     i:=wpop(3,1,1,'HILFE',ind);
     abbruch:=i;
     if abbruch > 0
     then
        begin
             fe.select;

             textbackground(blue);
             clrscr;

             reset(help_txt);

             flag:=0;
             while not eof(help_txt)
             do
             begin
                          read_ln;
                          if pos(ind2[i],str) > 0 then flag:=1;
                          if (flag=1) and (pos('<END>',str) > 0) then flag:=0;
                          str:=replace(str,'%T',zeit_str(akt_zeit));
                          str:=replace(str,#9,'        ');
                          if flag = 1 then alt_write(str);
             end;
             writeln;
             wart;
             close(help_txt);

        end;
        fe.close;
  until abbruch = 0;
end;

(* ------------------------------------------------------------------- *)


procedure fehler_MZ700_anzeige;
begin
                 writeln('MZ700A.ROM LADEFEHLER !! ');
                 writeln('Das ROM ist nicht vorhanden.',#10);
                 writeln('Bitte laden sie die MZ700LST.ZIP Datei aus dem Internet');
                 writeln('oder aber fertigen sie sich eine Kopie ihres Monitorroms an.');
                 writeln('Fr den Fall, da sie das LST-File benutzen,',
                         ' starten sie,');
                 writeln('nachdem das ZIP-FILE entpackt wurde,die  Programme GEN_ROMA.EXE');
                 writeln('und GEN_FNT.EXE !!!',#10,#10);
                 writeln('Please load MZ700LST.ZIP file from INTERNET');
                 writeln('or make a copy of your MZ700 ROM ');
                 writeln('after UNZIP the MZ700LST.ZIP ');
                 writeln('Start plase GEN_ROMA.EXE ');
                 writeln('and GEN_FNT.EXE ');
end;


procedure copr_anzeige(ver,DATUM:string);
begin

      textcolor(14);
      WRITELN('MZ80K/MZ700-EMU   (c) By M.Franzen  V'+ver+'  1997,98 ',datum,#13,#13);
      textcolor(7);
      writeln('UZ80-KERN         by pscardoso@lme.usp.br  ',#10);

      Writeln('Der Emulator darf nur als PD weitergegeben werden !!!',#10,#10);

      Writeln('MZ700      - 1');
      Writeln('MZ80K      -  ');


      writeln(#10,'NUMLock auf AUS  stellen !! ');
      writeln('PRESS PLEASE NUMLock OFF !! ');
      writeln(#13,'HILFE  - ALT F1 - ');
      writeln(#13,'HELP   - ALT F1 - ');

      (*
      writeln(#10,'TASTE ===> WEITER ');
      writeln('Press key to continue ');readln;
      *)

end;

end.