unit uinvader;

interface


uses crt,dos,kbd,MZio,Uz80,z80das;


function  invaders_in(eing:word):byte;
procedure invaders_out(nEnder, nValue: Word);
function  invaders_read(addr:word):byte;
procedure invaders_write(addr,eing:word);
procedure invaders_Int;
procedure start_invaders(eing:byte);
procedure reset_invaders;
implementation

var rom_path,
    r_name  :string;
    farbe:byte;
    var I_maschine:byte;

procedure reset_invaders;
begin
       aZ80Regs^.SP.W := $FF00;
       aZ80Regs^.PC.W := $0000;
end;



var  bbitmap,bBitmapPrevious,bShiftValue:byte;
function invaders_in(eing:word):byte;
var
  wValue: Word;
  nValue: Byte;
begin
  case (eing and $0F) of
    0:invaders_in:=244;
    1: begin
      nValue := $81;

      if test_Key(k1) = 1 then nValue := nValue or $04;
      if test_Key(k2) = 1 then nValue := nValue or $02;
      if test_key(k3) = 1 then nValue := nValue and (not $01);
      if test_Key(klf)= 1 then nValue := nValue or $20;
      if test_Key(krt)= 1 then nValue := nValue or $40;
      if test_Key(kctrl)=1 then nValue := nValue or $10;
      invaders_in:= nValue;
    end;
    2: begin
       nValue := $0;
       if test_Key(kT)=1 then nValue := nValue or $04;
       if test_Key(kP)=1 then nValue := nValue or $08;
       invaders_in:= nValue;
    end;
    3: begin
      wValue := (bBitmap shl 8) or bBitmapPrevious;
      wValue := wValue shl bShiftValue;
      nValue := wValue shr 8;
      invaders_in:= nValue;
    end
    else begin
      invaders_in:= 0;
    end;
  end;
end;

procedure invaders_out(nEnder, nValue: Word);
begin
  case (nEnder and $0F) of
    2: bShiftValue := nValue;
    3: begin
      {Sound Port}
      (* bSound1 := nValue; *)
    end;
    4: begin
      bBitmapPrevious := bBitmap;
      bBitmap := nValue;
    end;
    5: begin
      {Sound Port}
       (* bSound2 := nValue; *)
    end;
  end;
end;

procedure invaders_screen(Vaddr:word);  (* Farb_ROUTINE *)

(* Addr bei $4000 *)

begin

end;


procedure plot(x,y:word;farbe:byte);
begin

      mem[$A000:x+y shl 8]:=farbe;
end;


procedure refresh_invaders_crt;
begin
end;

const i_col:array[0..31] of byte = (6,6,15,15,15,15,15,15,   (* 7 *)
                                    14,14,14,14,14,14,14,14,   (* 15 *)
                                    14,14,14,14,14,14,14,14,   (* 23 *)
                                    14,10,10,13,9,14,13,13 );    (* 30 *)

procedure invaders_write(addr,eing:word);
var    x,y,i :word;
begin
        speicher^[addr]:=eing;


   if (addr >= $2400) and (addr <=$3fff)
     then
       begin


       x := (addr-$2400) shr 5;
       y := (addr-$2400) and $1f;



       if I_maschine <> 3
       then
               farbe:=i_col[y];



       for i:=0 to 7
       do
         if (eing and (1 shl (7-i))) > 0
               then
                    PLOT(10+x,250-(y shl 3)+i,farbe)
               else
                    PLOT(10+x,250-(y shl 3)+i,0);
       
      end;

end;

function  invaders_read(addr:word):byte;
begin
      invaders_read:=speicher^[addr];
end;

var nIntCont:longint;
procedure invaders_Int;
var  I, J: Integer;
begin
  Inc(nIntCont);
  aProcs[1].nPendingNMI := 0;
  if (nIntCont mod 2)=0
  then
    aProcs[1].nPendingIRQ := $000000D7
  else
    aProcs[1].nPendingIRQ := $000000CF; { FORCES A RST 8 }

end;



procedure load_invaders_system(eing:byte);
begin

    aZ80Regs := @aProcs;
    FillChar(aProcs, SizeOf(aProcs), 0);
    aProcs[1].nIM := 0;
    aProcs[1].nHalted := 0;
    aZ80Regs^.SP.W := $4F00;

    aProcs[1].oGetByteFunc   := invaders_READ;
    aProcs[1].oPutByteFunc   := invaders_write;
    aProcs[1].oOutByteFunc   := Invaders_Out;
    aProcs[1].oInByteFunc    := Invaders_In;
    aProcs[1].oInterruptFunc := invaders_int;
    aProcs[1].oMemory := speicher;


    aZ80Regs^.nMaxROM := $1FFF;


      aProcs[1].nMaxRAM := $5FFF;
      aProcs[1].nNMIInt := $010;
      aZ80Regs^.nMaxROM := $1FFF;
      aZ80Regs^.nMaxRAM := $5FFF;
      aZ80Regs^.SP.W := $4F00;

    aZ80Regs^.nTickMach:=60000;


    directvideo:=false;

    farbe:=14;

    case eing of
    1:
       begin
             r_name:='Space Invaders ';
             rom_path:=akt_dir+'\invaders\';
             loadrom(rom_path+'invaders.h',0,@speicher^[0]);
             loadrom(rom_path+'invaders.g',$800,@speicher^[0]);
             loadrom(rom_path+'invaders.f',$1000,@speicher^[0]);
             loadrom(rom_path+'invaders.e',$1800,@speicher^[0]);
       end;
    2:begin
             farbe:=9;
             r_name:='Lunar Rescue ';
             rom_path:=akt_dir+'\Lrescue\';
             loadrom(rom_path+'lrescue.1',0,@speicher^[0]);
             loadrom(rom_path+'lrescue.2',0,@speicher^[$800]);
             loadrom(rom_path+'lrescue.3',0,@speicher^[$1000]);
             loadrom(rom_path+'lrescue.4',0,@speicher^[$1800]);
             loadrom(rom_path+'lrescue.5',0,@speicher^[$4000]);
             loadrom(rom_path+'lrescue.6',0,@speicher^[$4800]);
        end;
    3: begin
             farbe:=13;
             r_NAME:='Rollinc ';
             rom_path:=akt_dir+'\rollingc\';
             loadrom(rom_path+'rc01.bin',0,@speicher^[0]);
             loadrom(rom_path+'rc02.bin',0,@speicher^[$400]);
             loadrom(rom_path+'rc03.bin',0,@speicher^[$800]);
             loadrom(rom_path+'rc04.bin',0,@speicher^[$0C00]);
             loadrom(rom_path+'rc05.bin',0,@speicher^[$1000]);
             loadrom(rom_path+'rc06.bin',0,@speicher^[$1400]);
             loadrom(rom_path+'rc07.bin',0,@speicher^[$1800]);
             loadrom(rom_path+'rc08.bin',0,@speicher^[$1C00]);
             loadrom(rom_path+'rc09.bin',0,@speicher^[$4000]);
             loadrom(rom_path+'rc10.bin',0,@speicher^[$4800]);
             loadrom(rom_path+'rc11.bin',0,@speicher^[$5000]);
             loadrom(rom_path+'rc12.bin',0,@speicher^[$5800]);
        end;
    4: begin
             r_name:='Super Invaders ';
             rom_path:=akt_dir+'\earthinv\';
             loadrom(rom_path+'earthinv.h',0,@speicher^[0]);
             loadrom(rom_path+'earthinv.g',$800,@speicher^[0]);
             loadrom(rom_path+'earthinv.f',$1000,@speicher^[0]);
             loadrom(rom_path+'earthinv.e',$1800,@speicher^[0]);
       end;

    end;

    aZ80Regs^.PC.W := $0;

end;


procedure start_invaders(eing:byte);
var i:byte;
begin
               fillchar(speicher^[0],$FFFF-32,$00);


               I_maschine:=eing;
               load_invaders_system(eing);

               writeln('INIT KEYB');
               neuer_tast_int;
               debug:=0;


               set_mode_q('');
               cls($A000,0);

               for i:=1 to 244
               do
                 plot(i,i,i);


               Evalinstr(1);
               Evalinstr(1);
               Evalinstr(1);
               Evalinstr(1);
               aZ80Regs^.PC.W := $0;


               repeat

                    Evalinstr(1);


                    if KF8 in tastatur then  aZ80Regs^.PC.W := $0;



               until kesc in tastatur;;


               restore_keyb;

               exit_run:=0;

               init_text;

end;

end.