unit UMZ700;

interface


uses bas,crt,dos,kbd,MZio,Uz80,z80das,fenst,umz_1r12;


procedure w_speicherMz700(addr:word;eing:word);
function  r_speicherMZ700(addr:word):byte;
procedure w_speicherMz1500(addr:word;eing:word);

function  MZ700_in(eing:word):byte;
function  MZ80_in(eing:word):byte;
procedure MZ700_out(adr,eing:word);

procedure MZxxx_INT;

procedure start_MZ(auswahl:byte);

procedure init_crt_LINEAR;

implementation


const File_type: array[0..8] of string[4] = ('???','OBJ','BTX','BSD','ASC',
                                             'BAS','666','777','888');

     MFtype = $10F0;    (* MONITOR *)
     MNAME  = $10F1;
     MSIZE  = $1102;
     Mload  = $1104;
     Mexec  = $1106;


     BFtype = $0FFC;    (* MZ700 CMT-BASIC *)
     BNAME  = $0FFD;
     BSIZE  = $100E;
     Bload  = $1010;
     Bexec  = $1012;


 LOADANDEXECUTE = 1;    (* TAPE *)

 MOTORSTOP = 0;
 MOTORON = 1;

 CMTHEADERGAPDETECT = 0;
 CMTHEADERTAPEMARKLONG =1  ;
 CMTHEADERTAPEMARKSHORT = 2;
 CMTAFTERHEADERTAPEMARK = 3;
 CMTHEADER = 4             ;
 CMTHEADERCHECKSUMM = 5    ;
 CMTDATAGAPDETECT = 6      ;
 CMTDATATAPEMARKLONG = 7   ;
 CMTDATATAPEMARKSHORT = 8  ;
 CMTAFTERDATATAPEMARK = 9  ;
 CMTDATA = 10              ;
 CMTDATACHECKSUMM = 11     ;
 CMTEND =12                ;

 motorstatus:byte = 0      ;
 CMTstatus  :byte = 0      ;
 cmtreadaccess:integer = 0 ;
 CMTReadAccessCounter:integer = 0 ;
 CMTCheckSumm:word = 0     ;
 CMTBitMask:byte   = 0     ;
 CMTBitCounter:word = 0    ;
 CMTByte:word=0            ;

 MZ700 = 0;
 MZ800 = 1;
 MZ80B = 3;


const MZmode:byte = 0;

var tape_count:word;
    tape_array:array[1..130] of byte;


(* ------------------ FDD ---------------------*)
var sektor, stopa, strana, fddstatus, fdderr, busy, secsize{0-256,1-512},
     busycnt,busy_status, sts_ok,only_256,v :Byte;{pro emulaci FDD}
     fdddata:array[0..512] of byte;{pole pro nacteni 1 sektoru}
     sect_size,laststep:word;
     count:word;

(* --------------------MZ800 -----------------------*)

var erom,
    graphicmode:byte;
    rovina:Byte;{zvolena graficka rovina, paleta}

    LSOF,SW,SSA,SEA,OLDSSA,OLDSEA:byte;
    frq,SOF,OLDSOF:word;

procedure reset_MZ800Video;
begin
     SSA:=0;SEA:=$7D;SW:=$7D;SOF:=0;OLDSOF:=0;
end;
(* ---- FD - INIT ------ *)

procedure sect256;assembler;
  asm
    xor ax,ax
    mov es,ax
    les bx,es:[1eh*4]
    mov byte ptr es:[bx+3],1
    ret
  end;

procedure sect512;assembler;
  asm
    xor ax,ax
    mov es,ax
    les bx,es:[1eh*4]
    mov byte ptr es:[bx+3],2
    ret
  end;

procedure set_secsize;assembler;
  asm
       cmp only_256,1 {jedeme pouze na 256 byte}
       jz @@x
       mov dl,stopa
       not dl
       mov dh,strana
       and dh,1
       cmp dh,1
       jnz @@01
       cmp ch,0
       jnz @@01
@@x:   mov sect_size,256
       call sect256
       jmp @@02
@@01:  mov sect_size,512
       call sect512
@@02:
       ret
  end;

procedure setup720;assembler;
  asm
    cmp stopa,0feh
    jnz @@02
    cmp sektor, 0feh
    jnz @@02
    mov ah,17
    mov al,2
    mov dl,1  {PCDRIVE A:0, B:1}
    int 13h
    mov ah,18
    mov ch,79
    mov cl,9
    mov dl,1  {PCDRIVE A:0, B:1}
    int 13h
@@02:ret
  end;

procedure readsec;assembler;
  asm
      call set_secsize
@@str:mov ax,seg fdddata
      mov es,ax
      mov ax,201h
      mov ch,stopa
      mov cl,sektor
      not cx
      mov dh,strana
      and dh,1
      mov dl,1 {PCdrive}
      mov bx,offset fdddata
      int 13h
      mov fdderr,0
      jnc @@1
      cmp sect_size,256
      jnz @@01
(*      mov ax,0
      mov dl,0 {PCdrive}
      int 13h*)
      mov sect_size,512
      call sect512
      jmp @@str
@@01: mov fdderr,0ffh
      call setup720
      mov ax,0
      mov dl,1 {PCdrive}
      int 13h
@@1:  mov busycnt,1;mov busy_status,1
      mov count,0
      ret
  end;


(* ---------- *)


procedure reset_MZ; forward;

procedure MZ_hard_reset;
begin
        CG_rom:=0 ;     (* CG_ROM ausgeblendet *)
        V_RAM:=0;       (* MZ800 VRAM ausgeblendet *)
        mH_rom:=1 ;     (* Vram einblenden *)
        mL_rom:=1 ;     (* Monitor_low eingeblendet *)
        Sys_schalter:=0*1+0*2+0*4+0*8+0*16+0*32+0*64+0*128;
        key_flag:=1;
        scroll:=0;
        v_contr_a:=0;
        frame:=0;
        sync:=1;
        lade_flag:=0;
        sound_enable:=0;
        tapetik:=0;
        dasam:=0;
        debug:=0;
        mzmode:=0;
        enable_bank:=1; (* Schreibschutz deaktiviert *)
        textbackground(blue);
        reset_MZ800Video;
end;

procedure show_char(addr:word);
var i:byte;
    Zeichen_matrix:pointer;
begin


      for i:=0 to 255     (* ROM *)
      do
         begin
                zeichen_matrix:= @rom^[Addr+i*8];
                put_patt_8(10+(i mod $F)*8,20+(i div $F)*8,14,2,
                   seg(zeichen_matrix^),ofs(zeichen_matrix^));

         end;

      for i:=0 to 255     (* RAM *)
      do
         begin
                zeichen_matrix:= @speicher^[Addr+i*8];
                put_patt_8(200+(i mod $F)*8,20+(i div $F)*8,14,2,
                   seg(zeichen_matrix^),ofs(zeichen_matrix^));

         end;

      gotoxy(1,21);write(hex(addr,4));


end;

procedure init_MZ700Pal;

const MZ700COLORS: array [0..23] of Byte = (0,0,0,0,35,58,63,0,0,60,21,51,21,63,21,32,63,63,63,63,10,63,63,63);
var reg:registers;
begin
      reg.ax:=$1012;                      {Do VGA dame paletu barev v MZ700}
      reg.bx:=0;
      reg.cx:=8;
      reg.es:=seg(mz700colors);
      reg.dx:=ofs(mz700colors);
      intr($10,reg);
end;


procedure init_crt_LINEAR;
var i:word;
begin
      init_mode_13;
      init_mz700pal;
      refresh_crt;
end;

procedure init_crt_tweake;
begin

end;


(* sharp 8253 Timer *)


function tiker_1:word; (* nicht bekannt was er macht *)
var h,m,s,hs :word;
begin
     gettime(h,m,s,hs);
     tiker_1:=(hs+100*s) and $FFFF;
end;


var MZ82         :byte;
    reg8_1       : array[0..1] of byte;
    reg8_2       : array[0..1] of byte;
    reg8_3       : array[0..1] of byte;
    reg8_4       : array[0..1] of byte;

    mz82FL_1,
    mz82FL_2,
    mz82FL_3,
    mz82FL_4    :byte;

    cloc:integer;


procedure  MZ8253_reset;
begin
     MZ82:=0;
     MZ82FL_1:=0;
     MZ82FL_2:=0;
     MZ82FL_3:=0;
     MZ82FL_4:=0;
     scount:=0;

end;


var tikk,frequenz:word;
var t82_teiler:word;



procedure  W_MZ8253(chan,eing:byte);
var  x:word;
begin
     case chan of
       1:
         begin


              if MZ82FL_1 = 1
              then
                   reg8_1[1]:=eing;

                   if (reg8_1[0]+reg8_1[1] shl 8) <> 0
                   then
                        frequenz:=1108800 div (reg8_1[0]+reg8_1[1] shl 8);

                   t82_teiler:=frequenz;
                   if mz82FL_1 = 1 then scount:=0;
                   reg8_1[mz82fl_1]:=eing;
                   mz82FL_1 := mz82FL_1  xor 1
         end;

       2:begin
              reg8_2[mz82FL_2]:=eing;
              mz82FL_2:=mz82FL_2 xor 1;
              cloc:=reg8_2[1] shl 8;
              cloc:=(cloc+reg8_2[0]) shl 1;
         end;

       3:begin
              reg8_3[mz82FL_3]:=eing;            (* UHR Setzen *)
              mz82FL_3:=mz82FL_3 xor 1;
              tikk:=reg8_3[0]+reg8_3[1] shl 8;
         end;
       4:;

      end;
end;


function R_MZ8253(chan:byte):byte;

begin
      case  chan of

       2:begin

              inc(cloc);
              cloc:=cloc mod $1FFFE;

              reg8_2[1]:=hi(cloc shr 1);
              reg8_2[0]:=lo(cloc shr 1);
              r_mz8253:=reg8_2[mz82fl_2];
              mz82FL_2:=mz82FL_2 xor 1;
         end;

       3:begin
              reg8_3[1]:=hi(tikk);        (* UHR / TIMER *)
              reg8_3[0]:=lo(tikk);
              r_mz8253:=reg8_3[mz82fl_3];
              mz82FL_3:=mz82FL_3 xor 1;

          end;

       1,4:begin
              reg8_4[1]:=hi(tiker_1);
              reg8_4[0]:=lo(tiker_1);
              r_mz8253:=reg8_4[mz82fl_4];
              mz82FL_4:=mz82FL_4 xor 1;
          end;


      end;
end;


(* ------------------ Speicherzugriff -------------------- *)


var adcinp :word;
    sound_timer:word;
    sound_delay:word;



function r_romMZ700(addr:word):byte;

begin
        if addr < $FFFF then r_romMZ700:=rom^[addr]
                        else r_romMZ700:=einsam2^[0];

        case addr
         of

         $E000: r_romMZ700:=255;

         $E008: begin
                     dec(sound_delay);

                     if sound_delay mod 1200*(CPU_speed+1)  = 0
                     then
                        dec(sound_timer);   (* mu gendert werden !!! *)

                     r_romMZ700:=$7e  or (sound_timer and 1) or $E;
                end;

         $E007: r_romMZ700:=r_mz8253(4);
         $E006: r_romMZ700:=r_mz8253(3);    (* UHR Lesen *)

         $E005:(* r_romMZ700:=r_mz8253(2) *);
         $E004:(* r_romMZ700:=r_mz8253(1) *);

         $E001: begin
                     lese_kbd;
                     r_romMZ700:=keyports[rom^[$E000] and $F];
                end;

         $E002: begin;
                      if (sync > 10)      (* Sync SIGNAL Bit 7*)
                      then
                        begin
                         rom^[$E002]:=0;
                         sync:=0;
                        end
                      else
                        begin
                         rom^[$E002]:=128;
                         inc(sync);
                        end;

                      (* MOTOR ON *)
                      if motorstatus = motoron
                        then
                          begin
                            rom^[$E002]:=rom^[$E002] or 16 ;

                            case cmtstatus
                            of
                              CMTHEADERGAPDETECT :
                              begin
                                   inc(cmtreadaccess);

                                   if(CMTReadAccess =  4) then CMTReadAccess:= 1;
                                   if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF;
                                   if(CMTReadAccess =  3) then
                                   begin
                                        rom^[$E002]:=rom^[$E002] and $DF;
                                        inc(CMTReadAccessCounter);
                                        if(CMTReadAccessCounter =  22000) then
                                        begin

                                             writeln('cmtheader');
                                             CMTStatus:= CMTHEADERTAPEMARKLONG;
                                             CMTReadAccessCounter:= 0;
                                        end;
                                   end;
                              end;

                              CMTHEADERTAPEMARKLONG :
                              begin
                                   inc(cmtreadaccess);

                                   if(CMTReadAccess =  4) then  CMTReadAccess := 1;
                                   if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF;
                                   if(CMTReadAccess =  3) then
                                   begin
                                        (* writeln('marklong'); *)
                                        inc(CMTReadAccessCounter);


                                        if(CMTReadAccessCounter =  40) then
                                        begin

                                             writeln('AA');
                                             CMTStatus:= CMTHEADERTAPEMARKSHORT;
                                             CMTReadAccessCounter:= 0;
                                        end;
                                   end;
                              end;

                            CMTHEADERTAPEMARKSHORT :
                            begin
                                 inc(CMTReadAccess);
                                 if(CMTReadAccess =  4) then CMTReadAccess := 1;
                                 if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF;
                                 if(CMTReadAccess =  3) then
                                 begin
                                      rom^[$E002]:=rom^[$E002] and $DF;
                                      inc(CMTReadAccessCounter);
                                      if(++CMTReadAccessCounter =  40) then
                                      begin
                                           writeln('bb');
                                           CMTStatus := CMTAFTERHEADERTAPEMARK;
                                           CMTReadAccessCounter := 0;
                                           CMTReadAccess := 0;
                                      end;
                                 end;
                            end;

                            CMTAFTERHEADERTAPEMARK :
                            begin
                                 inc(CMTReadAccess);
                                 if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF;
                                 if(CMTReadAccess =  3) then rom^[$E002]:=rom^[$E002] and $DF;
                                 if(CMTReadAccess =  5) then
                                 begin
                                      CMTStatus := CMTHEADER;
                                      CMTReadAccess := 0;
                                      CMTReadAccessCounter := 0;
                                      CMTCheckSumm := 0;
                                      CMTBitMask := $80;
                                      writeln('cc');
                                 end;
                            end;

                           CMTHEADER :
                           begin
                                inc(CMTReadAccess);
                                if(CMTReadAccess =  4)
                                then
                                    CMTReadAccess := 1;
                                if((CMTReadAccess =  3) and (CMTBitMask =  $00)) then
                                begin
                                     CMTReadAccess := 1;
                                     CMTBitMask := $FF;
                                     if(CMTReadAccessCounter =  128) then
                                     begin
                                          CMTStatus := CMTHEADERCHECKSUMM;
                                          CMTReadAccessCounter := 0;
                                          CMTBitMask := $80;
                                          writeln('dd');
                                     end;
                                end;
                                if(CMTReadAccess =  1)
                                then
                                    rom^[$E002]:=rom^[$E002] and $DF;

                                if(CMTReadAccess =  3) then
                                begin
                                     if(CMTBitCounter =  0) then
                                     begin
                                          CMTByte := 100; (*= fgetc(MZFile);*)
                                          CMTBitMask:= $80;
                                          inc(CMTReadAccessCounter);
                                     end;

                                     if((CMTByte and CMTBitMask) =  0)
                                     then
                                         rom^[$E002]:=rom^[$E002] and $DF
                                     else
                                         inc(CMTCheckSumm);

                                     CMTBitMask := CMTBitMask shr 1;

                                     INC(CMTBitCounter);
                                     if(CMTBitCounter =  8)
                                     then
                                         CMTBitCounter := 0;
                                end;
                             end;




                             CMTHEADERCHECKSUMM :
                             begin
                                  inc(CMTReadAccess);
                                  if(CMTReadAccess =  4) then CMTReadAccess := 1;
                                  if((CMTReadAccess =  3) and (CMTBitMask =  $00)) then
                                  begin
                                       CMTReadAccess := 1;
                                       CMTBitMask := $FF;
                                       if(CMTReadAccessCounter =  2) then
                                       begin
                                            write('dd');
                                            CMTStatus := CMTDATAGAPDETECT;

                                            CMTReadAccess := 0;
                                       end;
                                  end;
                                  if(CMTReadAccess =  1)
                                  then
                                      rom^[$E002]:=rom^[$E002] and $DF;
                                      if(CMTReadAccess =  3) then
                                      begin
                                           if(CMTBitCounter =  0) then
                                           begin
                                                inc(CMTReadAccessCounter);
                                                if(CMTReadAccessCounter =  1)
                                                then
                                                    CMTByte := CMTCheckSumm shr 8;

                                                if(CMTReadAccessCounter =  2)
                                                then
                                                    CMTByte :=CMTCheckSumm;
                                                    CMTBitMask := $80;
                                                end;
                                                if((CMTByte and CMTBitMask) =  0)
                                                then
                                                    rom^[$E002]:=rom^[$E002] and $DF;

                                                CMTBitMask := CMTBitMask shr 1;
                                                inc(CMTBitCounter);
                                                if(CMTBitCounter =  8)
                                                then
                                                     CMTBitCounter:= 0;
                                           end;
                                      end;


                            CMTDATAGAPDETECT :
                             begin
                                  inc(CMTReadAccess);
                                  if(CMTReadAccess =  4) then CMTReadAccess := 1;
                                  if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF;
                                  if(CMTReadAccess =  3) then
                                  begin
                                        rom^[$E002]:=rom^[$E002] and $DF;
                                        inc(CMTReadAccessCounter);
                                        if(CMTReadAccessCounter =  11000) then
                                              begin
                                                    CMTStatus := CMTDATATAPEMARKLONG;
                                                    CMTReadAccessCounter := 0;
                                                    writeln('ff');
                                               end;
                                  end;
                             end;


                            CMTDATATAPEMARKLONG :
                            begin
                                inc(CMTReadAccess);
                                if(CMTReadAccess =  4) then CMTReadAccess := 1;
                                if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF;
                                if(CMTReadAccess =  3) then
                                begin
                                     inc(CMTReadAccessCounter);
                                     if(CMTReadAccessCounter =  20) then
                                     begin
                                          CMTStatus := CMTDATATAPEMARKSHORT;
                                          CMTReadAccessCounter := 0;
                                          writeln('gg');
                                     end;
                                end;
                            end;

                           CMTDATATAPEMARKSHORT :
                           begin
                                inc(CMTReadAccess);
                                if(CMTReadAccess =  4) then CMTReadAccess := 1;
                                if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF ;
                                if(CMTReadAccess =  3) then
                                begin
                                     rom^[$E002]:=rom^[$E002] and $DF;
                                     inc(CMTReadAccessCounter);
                                     if(CMTReadAccessCounter =  20) then
                                     begin
                                          CMTStatus := CMTAFTERDATATAPEMARK;
                                          CMTReadAccessCounter := 0;
                                          CMTReadAccess := 0;
                                          WRITELN('hh');
                                     end;
                                end;
                           end;

                           CMTAFTERDATATAPEMARK :
                           begin
                                inc(CMTReadAccess);
                                 if(CMTReadAccess =  1) then rom^[$E002]:=rom^[$E002] and $DF ;
                                 if(CMTReadAccess =  3) then rom^[$E002]:=rom^[$E002] and $DF ;
                                 if(CMTReadAccess =  5) then
                                 begin
                                      CMTStatus := CMTDATA;
                                      CMTReadAccess := 0;
                                      CMTReadAccessCounter := 0;
                                      CMTCheckSumm := 0;
                                      CMTBitMask := $80;
                                      writeln('ii');
                                 end;
                           end;

                           end; (* ------------------------------------ *)

                          end
                        else
                           if test_key(kF12) = 1
                           then
                              begin;
                                     motorstatus:=motoron;
                                     sound(5000);
                                     delay(300);
                                     nosound;
                              end;;

                      (* ADC_IN *)

                      if random(255) > 170 then rom^[$E002]:=rom^[$E002] or 32;

                      (* BIT 6 Coursor blink *)

                      if (tiker_1  div 40) mod 2  = 0
                         then
                             rom^[$E002]:=rom^[$E002] and not 64
                         else
                             rom^[$E002]:=rom^[$E002] or 64;

                      end;


       end;
end;


procedure save_BIN(fname:string;fstart,fsize,fexec,attrib:word); forward;


const count_alt:word = 388;
      u:word = 0;
      t:word = 0;
      o_C:word = 0;

      data_count:word = 0;
      tape_wert:word=0;
      tape_name:string[14] ='';
      lgap:byte = 0;
      sgap:byte = 0;

      sync_str:string  = '';



procedure h_romMZ700(addr,eing:word);

const k:byte    =0;
begin

     if addr < $E009 then rom^[addr]:=eing ;   (* AB E00A kein RAM *)

     case addr
         of
          $E000: if lpt2 > $200
                 then
                     port[lpt2]:=(eing ) xor 255;

          $E004: W_MZ8253(1,eing);
          $E006: w_mz8253(3,eing);  (* Uhr setzten *)
          $E007: mz82FL_3:=0;       (* RESET 8253 chan 3  UHR *)
          $E008: begin
                      sound_enable:=eing and 1;

                      if sound_enable = 1 then
                       begin
                            if frequenz <= 150000
                            then
                                sound(frequenz);
                       end
                        else
                           nosound;


                      mz82fl_1:= 0; (* RESET 82xx *)
                 end;

          $E003:begin
                    if eing and 3 = 3   (* tape out *)
                        then
                              begin
                                  inc(t); sound(40000);

                                  if (tape_count < 500)
                                  then
                                    begin
                                      if tape_count > 200 then
                                       begin
                                            inc(u); k:=0;
                                       end;
                                    end
                                   else
                                     begin

                                        if sync_str <> 'LGAPSTML'
                                         then
                                           begin


                                            if u >= 22000 then sync_str:='LGAP';

                                            case u
                                            of
                                             11000:sync_str:='SGAP';
                                             256  :sync_str:='256S';
                                             40   :sync_str:=sync_str+'STM';
                                            end;

                                            if sync_str = 'LGAPSTM' then
                                             begin
                                               sync_str:=sync_str+'L';
                                               tape_count:=0;
                                               tape_wert :=0;
                                               data_count:=0;
                                               o_C:=0;

                                             end;
                                            end ;


                                            u:=0;
                                            k:=1;

                                     end;

                                   if sync_str = 'LGAPSTML'
                                   then
                                       begin
                                            sync_str:='HDR';
                                            (* MZ700_outf(0,1); *)
                                            exit;
                                       end;


                                   if sync_str = 'HDR'
                                       then
                                        if (tape_count > 200)  and ( tape_count < 900 )
                                               then
                                                  begin

                                                     tape_wert:=tape_wert or (k shl (8-(o_c)));

                                                     if o_C = 8
                                                         then
                                                             begin
                                                                  inc(data_count);
                                                                  if tape_wert > $ff
                                                                  then
                                                                      tape_array[data_count]:=tape_wert and $FF;

                                                                  tape_wert:=0;

                                                                  if data_count = 100
                                                                     then
                                                                        begin
                                                                             tape_name:='';
                                                                             o_c:=1;
                                                                             while tape_array[o_c] <> 13
                                                                             do
                                                                               begin
                                                                                  if tape_array[o_c] > 32
                                                                                     then
                                                                                         tape_name:=tape_name+
                                                                                         chr(tape_array[o_c]);
                                                                                  inc(o_c);
                                                                               end;
                                                                            save_bin(tape_name,
                                                                                     r_word(@tape_array[21]),
                                                                                     r_word(@tape_array[19]),
                                                                                     r_word(@tape_array[23]),
                                                                                     tape_array[1]);
                                                                        end;
                                                                  o_c:=0;
                                                             end
                                                     else
                                                          inc(o_C);;
                                                   end;
                                  tape_count:=0;
                              end
                          else
                                    nosound;
                end
          else
              tape_count:=0;

          (* $E003 and 3 = 1  Tapeout High *)
         end;


         if (addr >= $D000)  and (addr <=$d3e7)
              then
                   Sharp700_screen(addr);


         if (addr >= $D800)  and (addr <=$DBE7)
           then
                Sharp_farbram(addr);


end;


(* ------------------------------------------------------------------------*)

function r_speicherMZ700(addr:word):byte;
var wait:word;


begin
     inc(tape_count);

     if addr < $FFFF then r_speicherMZ700:=speicher^[addr]
                     else r_speicherMZ700:=einsam1^[0];




        if mL_rom = 1   (* Monitor *)
         then
             if addr <= $FFF
                then
                    r_speicherMZ700:=rom^[addr];

         if CG_rom = 1  (* Graphicrom / ram  *)
            then
               if ((addr >= $1000) and (addr <=$1FFF)) or
                  ((addr >= $C000) and (addr <=$CFFF))
                then
                    r_speicherMZ700:=rom^[addr];

         if (addr >=$D000) and (mH_rom = 1) then r_speicherMZ700:=r_romMZ700(addr);
end;


(* -------------------------------------------------------------------------*)

procedure w_speicherMz700(addr:word;eing:word);

begin

       if (addr <=$FFF)                         (* Monitor ROM LOw *)
       then
        begin
             if mL_rom = 0
                then
                  speicher^[addr]:=eing;         (* RAM *)
        end
       else

       begin

        if (addr >= $C000) and (addr <=$CFFF)    (* Zeichengenerator *)
        then
         if CG_rom = 1
             then
                 begin
                    rom^[addr]:=eing;;
                    refresh_crt;                 (* nderungen sichtbar machen *)
                 end
             else
               if enable_bank = 1                (* RAM ist bei 0 schreibgeschtzt *)
                 then
                    speicher^[addr]:=eing;       (* RAM *)

        if (addr >= $D000) and (mh_rom = 1)      (* Videoram und Controls *)
          then
               h_romMZ700(addr,eing)
          else
             if enable_bank = 1
              then
                 if addr < $FFFF then speicher^[addr]:=eing
                                 else einsam1^[0]:=eing;   (* RAM *)
        end;
end;

(* -------------------------------------------------------------------------*)
procedure w_speicherMz1500(addr:word;eing:word);

procedure h_rom;

const zo:byte = 40;
    
begin

     if addr < $E00A then rom^[addr]:=eing ;

     case addr
         of
         (* $E003 MODE SET 8253 *)
          $E004: W_MZ8253(1,eing);
          $E006: w_mz8253(3,eing);  (* Uhr setzten *)
          $E007: mz82FL_3:=0;       (* RESET 8253 chan 3  UHR *)
          $E008: begin
                      sound_enable:=eing and 1;
                      mz82fl_1:= 0; (* RESET 82xx *)
                 end;
          $E003:begin

                    if eing and 3 = 3
                        then
                              begin
                                  sound(40000);
                                  gotoxy(1,1);writeln(hex(tape_count,4));
                                  tape_count:=0;
                              end
                          else
                                    nosound;
                end;

          (* $E003 and 3 = 1  Tapeout High *)
         end;

         if (addr >= $D000)  and (addr <=$d3e7)
              then
                   Sharp700_screen(addr);

         if (addr >= $D400)  and (addr <=$D867)
              then
                  begin
                     Sharp700_screen(addr-$400);
                     Sharp1500_screen($D400,addr);
                  end;

         if (addr >= $D800)  and (addr <=$DBE7)
           then
                Sharp_farbram(addr);

end;

begin

       if (addr <=$FFF)                         (* Monitor ROM LOw *)
       then
        begin
             if mL_rom = 0
                then
                  speicher^[addr]:=eing;         (* RAM *)
        end
       else

       begin

        if (addr >= $C000) and (addr <=$CFFF)    (* Zeichengenerator *)
        then
         if CG_rom = 1
             then
                 begin
                    rom^[addr]:=eing;;
                    refresh_crt;                 (* nderungen sichtbar machen *)
                 end
             else
               if enable_bank = 1                (* RAM ist bei 0 schreibgeschtzt *)
                 then
                    speicher^[addr]:=eing;       (* RAM *)

        if (addr >= $D000) and (mh_rom = 1)      (* Videoram und Controls *)
          then
               h_rom
          else
             if enable_bank = 1
              then
                 if addr < $FFFF then speicher^[addr]:=eing
                                 else einsam1^[0]:=eing;   (* RAM *)
        end;

end;


(* -------------------------------------------------------------------------*)


function MZ700_in(eing:word):byte;
var x:byte;

begin
      x:=255;

      case eing and $FF
      of

          (* -------- MZ QD  --------------*)

          (*
          $F4:x:=0;

          $F5:x:=random(255);

          (*
          $F6:x:=random(255);

          $F7:x:=random(255);
          *)

          (* -------- MZ 800 --------------*)


          $D0:x:=r_romMZ700($E000);
          $D1:x:=r_romMZ700($E001);
          $D2:x:=r_romMZ700($E002);
          $D3:x:=r_romMZ700($E003);
          $D4:x:=r_romMZ700($E004);
          $D5:x:=r_romMZ700($E005);
          $D6:x:=r_romMZ700($E006);
          $D7:x:=r_romMZ700($E007);


          (* ---- Fd IN ----- *)

{}
{JAKO ZE MAME PRIPOJENOU FDD}
$d8:begin
    asm
          cmp busycnt,0
          jz @@1
          dec busycnt
          mov bl,00000001b
          not bl
          jmp @@end
    @@1:  cmp fdderr,0
          jz @@2
          mov bl,00011000b
          not bl
          jmp @@end
    @@2:  cmp busy_status,1
          jz @@20
          cmp busy_status,2
          jnz @@00
    @@20: mov bx,count
          cmp bx,sect_size
          jnz @@21
          cmp busy_status,2 {write sector}
          jnz @@22
          {call writesec}
          jmp @@1
    @@22: mov busy_status,0
          mov bl,00000000b
          not bl
          jmp @@end
    @@21: mov bl,00000011b
          not bl
          jmp @@end
    @@00: mov bl,00000000b
          or bl, sts_ok
          not bl
    @@end:mov x,bl
    end;
    end;
$D9:x:=stopa;
$DA:x:=sektor;
$DB:begin
    {gotoxy(1,10);write('strana:',(strana and 1),' stopa:',not(stopa),' sektor:',not(sektor));}
    x:=not(fdddata[count]);
{    writeln(count,':',x);}
{    writeln(hex(x,2),' ',hex(count,2));delay(100);}

    inc(count);
{
    if (not(stopa)=0) and ((strana and 1)=1) then
       if count>$ff then begin fddstatus:=0;count:=0;end else}
   (* if count>({2*$ff}sect_size) then begin fddstatus:=0;count:=0;end;*)



    end;
$DD:x:=strana;



          (* ----------- MZ 1R12 ----------*)

          $F8:reset_Ur12;
          $F9:x:=read_Ur12;

          (* ------------------------------*)


          $E0:begin
          case mzmode of
                      0: cg_rom:=1;
                      1: begin
                               cg_rom:=1;
                               v_ram:=1;
                               write('aaa');
                         end;
               end;
               end;
          $E1:begin
          case mzmode of
                      0: cg_rom:=0;
                      1: begin
                               cg_rom:=0;v_ram:=0;
                         end;
              end;
              end;

          (*
          $E0:CG_rom:=1;
          $E1:CG_rom:=0;
          *)
          $FE:x:=random(16) and $D;  (* Printer READY MZ700/800 *)
          $CE:x:=sys_schalter;       (* Betriebsart MZ700 / MZ800 *)
      end;


     MZ700_in:=x;
end;



function MZ80_in(eing:word):byte;
var x:byte;

begin
      x:=255;
      case eing and $FF
      of
          $FE:x:=random(16) and $D;  (* Printer READY MZ700/800 *)
      end;

     MZ80_in:=x;
end;



procedure MZ700_cls;
var i:word;

begin
     for i:=$D000 to $D3E7 do rom^[i]:=0;
     for i:=$D800 to $DBE7 do rom^[i]:=blue + 7 shl 4;
end;



(* ------------------------ S A V E _ R O U T I N E S ---------------- *)



procedure save_BIN(fname:string;fstart,fsize,fexec,attrib:word);
var   fwert,
      buff :byte;
      k:word;

begin
                  writeln('NAME  :',fname,'.',File_type[attrib]);

                  if attrib = 0
                  then
                      fname:=fname+'.bin'
                  else
                      fname:=fname+'.'+file_type[attrib];


                  writeln(hex(fstart,4),' ',hex(fsize,4),' ',hex(fexec,4));

                  assign(tapefile,fname);
                  rewrite(tapefile);


                  fwert:=attrib;     (* Attribut der Datei *)
                  write(tapefile,fwert);

                  (* start *)

                  fwert:=lo(fstart);
                  write(tapefile,fwert);
                  fwert:=hi(fstart);
                  write(tapefile,fwert);

                  (* size *)

                  fwert:=lo(fsize);
                  write(tapefile,fwert);
                  fwert:=hi(fsize);
                  write(tapefile,fwert);


                  (* EXEC *)

                  fwert:=lo(fexec);
                  write(tapefile,fwert);
                  fwert:=hi(fexec);
                  write(tapefile,fwert);


                  (* WRITE MEMORY *)

                  for k:=fstart to fstart+fsize   (* 27.OKT 98 *)
                  do
                   begin
                    buff:=r_speicherMZ700(K) and $FF;
                    write(tapefile,buff);
                   end;

                  CLOSE(tapefile);
                  motorstatus:=motorstop;
end;


procedure save_MZ700_BASICFILE;
var i:word;
    taste:char;
begin

        gotoxy(1,1);
        textbackground(blue);

           writeln;

           

           if (r_word(@speicher^[$6AB3])-r_word(@speicher^[$6ABF])) > 2
           then
               begin

                     writeln('BAS Start   :',hex(r_word(@speicher^[$6ABF]),4));
                     writeln('BAS END     :',hex(r_word(@speicher^[$6AB3]),4));
                     writeln('BAS Len     :',hex(r_word(@speicher^[$6AB3])-r_word(@speicher^[$6ABF]),4));
                     writeln('BAS Ftype   :',File_type[speicher^[Bftype]]);
                     dateiname:='';
                     taste:=#0;

                     restore_keyb;
                     repeat

                           repeat
                                 write('Filename (no extension ) ? '); readln(dateiname);
                           until Dateiname <> '';

                           if exist(dateiname+'.'+File_type[speicher^[Bftype]]) = true
                              then
                                begin
                                  writeln('Warning :',dateiname,' exist !!'+#10,#13,' owerwite (Y)es / (N)o ?');
                                  repeat
                                        taste:=upcase(readkey);
                                  until taste in ['Y','J','N'];
                                end;

                     until (exist(dateiname+'.'+File_type[speicher^[Bftype]]) = false) or (taste in ['Y','J']);

                     neuer_tast_int;
                     loesche_tasten;

                     save_BIN(dateiname,r_word(@speicher^[$6ABF]),
                                        r_word(@speicher^[$6AB3])-r_word(@speicher^[$6ABF]),
                                        0000,
                                        speicher^[Bftype]);
                     init_mz700pal;
                     Refresh_crt;
               end
               else
                   writeln('No BASICprogram in memory !!');
end;




(* ---------------------- L O A D _ R O U T I N E S ------------------ *)


var  MZdatei  :file of byte;

procedure load_display(k:word);
begin
end;


procedure read_block(start,leng:word);
var i    :word;
begin


      for i:=start to start+leng-1
      do
        begin
         read(MZdatei,speicher^[i]);
         sound(1000+(speicher^[i] and 16)*1000);
         load_display(i);
        end;

      nosound;
      close(MZdatei);

      lade_flag:=0;

      aZ80Regs^.AF.W:=0;
end;


procedure load_image(name:string;schalter,auswahl:byte);

(* LADER fr xxxxx.M12 Files      *)
(* O - 127             HEADER     *)
(* 128 - ende          Programm   *)
(* SHALTER = 1   keine ABFRAGE    *)
(* Schalter  0 = MC   1 = MZ700 BASIC *)

var   i,z:word;
      x:byte;
  start,
  ende,
  exec,
  typ,
  leng:word;
  rnumb:word;
  buff :array[0..129] of byte;
begin
if name <> 'ESCAPE'
then
    begin
      textcolor(13);


      assign(MZdatei,name);
      reset(MZdatei);
                                        (* LOAD Header   *)
      for i:=0 to 127
      do
        read(MZdatei,buff[i]);

      typ  :=buff[0];
      start:=r_word(@buff[$14]);
      leng :=r_word(@buff[$12]);
      exec :=r_word(@buff[$16]);


      if start < $1000 then begin ML_rom:=0; MH_rom:=1; end;  (* RAM einbanken *)


      if auswahl = 0
      then
         begin
           speicher^[MFtype]:=typ;
           w_word(@speicher^[$1104],start);
           w_word(@speicher^[$1102],leng);
           w_word(@speicher^[$1106],exec);

           for i:=1 to ord(name[i])
           do
             speicher^[i+Mname-1]:=ord(name[i]);

           speicher^[Mname+i]:=$0D;

         end;


      if auswahl = 1    (* BASIC  MZ700 *)
      then
       begin
           speicher^[BFtype]:=typ;
           w_word(@speicher^[$1010],start);
           w_word(@speicher^[$100E],leng);
           w_word(@speicher^[$1012],exec);
           w_word(@speicher^[$6AB3],(start+leng));

       end;

      writeln('Start:',hex(start,4));   (* Programminfo  *)
      writeln('End  :',hex(start+leng,4));
      writeln('LEN  :',hex(leng,4));

      writeln('EXEC :',hex(exec,4));
      writeln('FTyp :',File_type[typ]);

      if schalter = 1
      then
        begin
             if exec_FRAGE = 1
             then
               begin
                  aZ80Regs^.pc.W:=exec;       (* SET PC        *)
                                              (* LOAD PROGRAMM *)
                  init_mz700pal;
                  refresh_crt;

               end
             else
                  aZ80Regs^.pc.W:=0;
        end
      else
           aZ80Regs^.pc.W:=exec;


      read_block(start,leng);

    end;
end;





function load_BIN(name:string;schalter,auswahl:byte):word;

var   i,z:word;
      x:byte;
  start,
  ende,
  exec,
  typ,
  leng:word;

  buff :array[0..7] of byte;
begin
if name <> 'ESCAPE'
then
    begin
      textcolor(11);
      assign(MZdatei,name);
      reset(MZdatei);

      for i:=0 to 6                     (* LOAD Header   *)
      do
        read(MZdatei,buff[i]);


      typ:=buff[$0];
      start:=r_word(@buff[$1]);
      leng :=r_word(@buff[$3]);
      exec :=r_word(@buff[$5]);

      if start < $1000 then begin ML_rom:=0; MH_rom:=1; end;  (* RAM einbanken *)

      if auswahl = 0
      then
         begin
           speicher^[MFtype]:=typ;
           w_word(@speicher^[$1104],start);
           w_word(@speicher^[$1102],leng);
           w_word(@speicher^[$1106],exec);
           (*
           for i:=1 to ord(name[i])
           do
             speicher^[i+Mname-1]:=ord(name[i]);
           *)
           speicher^[Mname+i]:=$0D;



         end;


      if auswahl = 1    (* BASIC  MZ700 *)
      then
       begin
           speicher^[BFtype]:=typ;
           w_word(@speicher^[$1010],start);
           w_word(@speicher^[$100E],leng);
           w_word(@speicher^[$1012],exec);
           w_word(@speicher^[$6AB3],(start+leng));

       end;

      writeln('Start:',hex(start,4));   (* Programminfo  *)
      writeln('End  :',hex(start+leng,4));
      writeln('LEN  :',hex(leng,4));

      writeln('EXEC :',hex(exec,4));
      writeln('FTyp :',File_type[typ]);

      load_bin:=0;

      if (schalter = 1) and (typ <> 2)
      then
        begin

        if exec_FRAGE = 1
           then
            load_bin:=exec              (* SET PC        *)
           ELSE
              LOAD_bin:=0;
        end;

      i:=start;

      read_block(start,leng);

    end;
end;

procedure load_MULTI_image(dateiname:string);
begin

      mz_1500_mode:=0;

      aProcs[1].oPutByteFunc := w_speicherMz700;

             if dateiname <> 'ESCAPE'
                then
                          begin
                                  MZ_hard_reset;


                                  if pos('.M12',dateiname) > 0
                                    then
                                           load_image(dateiname,1,0);


                                   if pos('.MZT',dateiname) > 0       (* MZ1500 *)
                                    then
                                        begin
                                           load_image(dateiname,1,0);
                                           mz_1500_mode:=1;
                                           aProcs[1].oPutByteFunc := w_speicherMz1500;
                                        end;

                                  if pos('.BIN',dateiname) > 0
                                    then
                                            aZ80Regs^.pc.W:=load_BIN(dateiname,1,0);

                                   if pos('.OBJ',dateiname) > 0
                                    then
                                            aZ80Regs^.pc.W:=load_BIN(dateiname,1,0);


                                   if pos('.BTX',dateiname) > 0   (* BTX MZ80K BASIC *)
                                    then
                                        load_BIN(dateiname,1,0);

                                  if pos('.MZ7',dateiname) > 0
                                    then
                                             load_MZ7(dateiname);

                                  if pos('.P',dateiname) > 0
                                    then
                                             load_MZ7(dateiname);



                                  writeln('DONE');
                          end
                             else
                                  aZ80Regs^.pc.W:=0;;

             loesche_tasten;
end;


(* ------------------------------------------------------------------ *)

procedure select_file(ext:string);
begin
     restore_keyb;
     directvideo:=true;
     init_text;
     textcolor(14);
     textbackground(1);

     dateiname:=windir('','*.'+ext);

     neuer_tast_int;
     init_crt;
     refresh_crt;
     directvideo:=false;
     loesche_tasten;
end;

procedure load_monitor_file;
begin

end;

var fname:string;
    fsize,
    fstart,
    fexec:word;
    fwert:byte;



procedure MZ700_out(adr,eing:word);
var   k:word;
      p:byte;
begin

     (* Hier die Monitor I/o *)
     (* if hi(adr) = $F then
     begin
     *)

     case adr and $FF
      of
          $2:write(chr(lo(aZ80Regs^.af.w)));  (* FR TESTROUTINEN *)
          $1:begin  (* LOAD *)

                  case eing
                  of
                     1:lade_flag:=1;     (* MONITOR *)
                     2:lade_flag:=2;     (* BASIC  700 *)
                     3:begin
                            select_file('M12;*.obj;*.BTX;*.bas;*.bsd');
                            load_MULTI_image(Dateiname);
                       end;     (* BLOCK-LOAD *)

                  end;

             end;

          $0:begin  (* SAVE *)
             case eing
             of
              2:save_MZ700_BASICFILE;
              1:
                begin

                  fname:='';
                  fstart:=speicher^[$1104]+speicher^[$1105] shl 8;
                  fexec :=speicher^[$1106]+speicher^[$1107] shl 8;
                  fsize :=speicher^[$1102]+speicher^[$1103] shl 8;


                  k:=$10F1;

                  repeat

                        if chr(speicher^[k])  in ['A'..'Z','0'..'9','a'..'z']
                        then
                            fname:=fname+chr(speicher^[k]);
                        inc(k);

                  until speicher^[k] = $0D;


                  if fname <> ''
                     then
                         save_bin(fname,fstart,fsize-1,fexec,speicher^[MFtype]);

                  writeln(fname);
                  writeln(hex(fstart,4));
                  writeln(hex(fsize,4));
                  writeln(hex(fexec,4));



                  refresh_crt;

                end;
               end;
             end;
          end;
     (* end;  *)

     case adr and $FF
          of

          (* -------- Bankumschaltung --------- *)
               {Mapovani pameti}
          $E0:begin ml_rom:=0;cg_rom:=0;end;
          $E1:begin
              case mzmode of
              0: mH_rom:=0;
              1: erom:=0;
              end;
              end;
          $E2:ml_rom:=1;
          $E3:begin
              case mzmode of
              0: mh_rom:=1;
              1: erom:=1;
              end;
              end;
          $E4:begin
              case mzmode of
              0: begin ml_rom:=1;MH_rom:=1;cg_rom:=0;end;
              1: begin ml_rom:=1          ;cg_rom:=1;v_ram:=1;erom:=1;end;
              end;
              end;
          (*
          $E0:mL_rom:=0;
          $E1:mH_rom:=0;
          $E2:mL_rom:=1;
          $E3:mh_rom:=1;
          $E4:begin;
                    mL_rom:=1;
                    MH_rom:=1;
              end;
          *)

          $E5:enable_bank:=0;
          $E6:enable_bank:=1;
          (* -------- MZ QD  --------------*)

          (* -------- MZ 1R12 CMOS --------*)

          $F8:set_Ur12_seekhi(eing);
          $F9:set_Ur12_seeklo(eing);
          $FA:write_Ur12(eing);

          (* -------- MZ 800 --------------*)

          {}
          {Zmena systemoveho modu MZ800/MZ700 a grafiky}
          $CE:begin
                                  graphicmode:=eing and $f;
                                  case eing and $c of
                                  0: if mzmode = 0 then
                                     begin
                                       mzmode:=1;erom:=mh_rom;(*320vram*)v_ram:=0;
                                     end;
                                     (* else initmode320; *)
                                 (*
                                  4: if mz800mode=0 then
                                     begin
                                       mz800mode:=1;erom:=mh_rom;initmode640;vram:=cg_ram;
                                     end
                                     else initmode640;
                                  end;
                                  *)
                                  (*
                                  fillchar(palety[0],$f,$ff);initdfltpal;
                                  *)
                                  end;


               if (eing and $f)=8 then

               if mzmode=1 then
                              begin
                                   mzmode:=0;mh_rom:=erom;init_crt;
                              end
                                else init_crt;


               end;
{}


          $D0:h_romMZ700($E000,eing);
          $D1:h_romMZ700($E001,eing);
          $D2:h_romMZ700($E002,eing);
          $D3:h_romMZ700($E003,eing);
          $D4:h_romMZ700($E004,eing);
          $D5:h_romMZ700($E005,eing);
          $D6:h_romMZ700($E006,eing);
          $D7:h_romMZ700($E007,eing);

          (* ---- FD out --------*)


{Tady bude emulace FDD}
$D9:stopa:=eing;
$d8:begin
  asm
         pusha
         mov fdderr,0
         mov bx,eing
         not bl
         mov bh,bl
         and bl,11100000b
         jz @@1
         test bl,10000000b
         jnz @@2
         cmp bl,00100000b
         jnz @@0001
         cmp laststep,0
         jz @@step_in
         jmp @@step_out
@@0001:  cmp bl,01000000b
         jnz @@0002
@@step_in: dec stopa
         mov laststep,0
         jmp @@01
@@0002:
@@step_out:inc stopa
         mov laststep,1
@@01:    mov busycnt,1;mov busy_status,0
         cmp stopa,0ffh
         mov sts_ok,0
         jnz @@02
         mov sts_ok,00000100b
@@02:    jmp @@end
@@1:     test bh,00010000b
         jnz @@01
         mov stopa,0ffh
         jmp @@01
@@2:     mov sts_ok,0
         cmp bl,10000000b
         jnz @@4
         call readsec
         jmp @@end
@@4:     cmp bl,10100000b
         jnz @@5
         mov count,0
         mov busycnt,1;mov busy_status,2
         jmp @@end
@@5:     mov bl,bh
         and bl,11110000b
         cmp bl,11010000b
         jnz @@6
         jmp @@end
@@6:     cmp bl,11000000b
         jnz @@7
         mov count,0
         mov sect_size,6
         mov busycnt,1;mov busy_status,1
         mov bl,stopa

              mov byte ptr es:[fdddata], bl
              mov bl,sektor
              mov byte ptr es:[fdddata+1], bl
              mov bl,strana
              mov byte ptr es:[fdddata+2], bl
              mov bl,10b;not bl
              mov byte ptr es:[fdddata+3], bl
              mov bx,0
              mov word ptr es:[fdddata+4], bx
         jmp @@end
@@7:     {osetreni spatneho prikazu pro FDD}
@@end:popa
  end;

              end;
$DA:sektor:=eing;
$DD:strana:=eing;

{}
          (* ------------------------------*)

          255:begin                     (* Printer ===> MZPrint.txt *)
                 sound(50);
                 p:=eing and $FF;
                 write(mzprint,p);
                 if p = 13              (* INSERT Newline *)
                     then
                       begin
                         p:=10;
                         write(mzprint,p);
                       end;

                 nosound;
             end;
        end;
end;



var int_tik:byte;

procedure MZxxx_INT;
var i,v,
     h,m,s,hs :word;
begin
     dec(int_tik);
     

     gettime(h,m,s,hs);

     if int_tik mod 10  = 0
     then
         dec(tikk);   (* 8255 TIMER CHANEL 3 Uhr *)


     for i:=0 to cpu_speed  do  for v:=0 to $FFFF do ;

     sync:=1;         (* Bildwechsel *)


     if mz_1500_mode = 1
     then
       begin
            inc(scount);
            if scount < 100
            then
            sound(frequenz)
       else
           nosound;
     end;

end;

(* ------------------------------------------------------------------ *)

procedure reset_MZ;
begin
      MZ8253_reset;
      MZ_hard_reset;
      pb_select:=0;
      nosound;

      MZ_1500_mode:=0;
      MZ_800_mode:=0;

      loesche_tasten;

      (* Reset Z80 *)

      FillChar(aProcs, SizeOf(aProcs), 0);
      aZ80Regs := @aProcs;
      aZ80Regs^.SP.W := $FF00;
      aZ80Regs^.PC.W:=0;

      aProcs[1].nIM := 0;
      aProcs[1].nHalted := 0;
      aProcs[1].nPendingNMI := 1;

      aZ80Regs^.IFF1 := 1;
      aZ80Regs^.IFF2 := 1;
      
      aProcs[1].oGetByteFunc := r_speicherMZ700;
      aProcs[1].oPutByteFunc := w_speicherMz700;
      aProcs[1].oOutByteFunc := MZ700_out;
      aProcs[1].oInByteFunc  := MZ700_in;
      aProcs[1].oInterruptFunc := MZxxx_INT;

      aProcs[1].oMemory := speicher;
      (* aProcs[1].nMaxRAM := $FFFF *); (* ADRESSE AB DER EXTERNE PROCEDUREN *)
                                        (* DEN SPEICHER ANSPRECHEN SOLLEN *)
      aZ80Regs^.nMaxROM := $0;
      aZ80Regs^.nMaxRAM := $FFFF;

      aProcs[1].nNMIInt := $0;

      dasam:=0;
end;

(* ------------------------------------------------------------------- *)
procedure F_key;   (* Diverse Laderoutinen *)
var i:word;
begin


                             if testmem_key(kF8) = 1    (* RESET *)
                                   then
                                      begin
                                             if tapetik = 255
                                                  then
                                                   begin
                                                       writeln('RESET');

                                                       tapetik:=0;
                                                   end;
                                                  o_C:=0;
                                                  gotoxy(1,1);
                                                  reset_mz;
                                                  loesche_tasten;
                                      end;

                             if testmem_key(kF4) = 1    (* Debugmode ein *)
                                then
                                   begin
                                       init_mode_640;
                                       inc(debug);
                                       if debug > 1
                                          then dasam:=1;
                                       loesche_tasten;
                                       refresh_crt;
                                       gotoxy(41,1);
                                   end;



                             if testmem_key(kF11) = 1 then
                               begin
                             if testmem_key(Kctrl) = 1
                             then
                               begin
                                    select_file('M12;*.bin;*.BSD;*.BAS');
                                      if pos('.M12',dateiname) > 0
                                       then
                                          load_image(dateiname,0,1)
                                       else
                                          load_bin(dateiname,0,1);
                                      init_mz700Pal;
                                      refresh_crt;
                                    end
                                   else
                                     begin
                                        MZ_hard_reset;
                                        load_image(akt_dir+'\MZ700bas.M12',0,0);
                                        loesche_tasten;
                                        MZ700_cls;
                                        init_mz700pal;
                                        refresh_crt;
                                     end;
                               end;


                             if testmem_key(kF12) = 1
                             then
                              if testmem_key(Kctrl) = 1
                                then
                                   begin
                                    inc(cpu_speed,5);
                                    if cpu_speed > 40 then cpu_speed:=0;
                                    gotoxy(1,1);write('CPU_Delay:',cpu_speed);
                                    repeat until tastatur = [];
                                    refresh_crt;
                                   end;

                             (* Load Files *)

                             if testmem_key(kF9) = 1     (* MZ700  *)
                             then
                               if testmem_key(Kctrl) = 1
                                   then
                                      save_MZ700_BASICFILE;


                             if testmem_key(kF12) = 1 then
                             begin
                                  show_char(debug_CRT);
                                  inc(debug_crt,$FF);
                             end;


                             if testmem_key(kF1) = 1 then
                             begin
                               restore_keyb;
                               textmode(co80);
                               help('MZxxx.HLP');
                               neuer_tast_int;
                               init_crt;

                               refresh_crt; speicher^[$11a4]:=0;
                               directvideo:=false;
                               loesche_tasten;
                             end;

                             if testmem_key(kF6) = 1 then
                             begin
                                   init_JAPAN_FNT;

                                   refresh_crt;
                                   directvideo:=false;
                                   loesche_tasten;
                                   sound(2000);
                                   delay(100);
                                   nosound;
                             end;


                             if testmem_key(kF7) = 1 then
                             if testmem_key(Kctrl) = 1
                             then
                               begin
                                  select_file('obj;*.bin;*.MZ7;*.M12;*.MZT;*.BTX;*.bas');
                                  load_MULTI_image(Dateiname);
                               end
                             else
                               begin
                                   init_internat_FNT;
                                   refresh_crt;
                                   directvideo:=false;
                                   loesche_tasten;
                                   sound(1000);
                                   delay(100);
                                   nosound;
                             end;


                             if test_key(kesc) = 1 then exit_run:=1;

end;

(* ------------------------------------------------------------------- *)

var  einzelschritt,
     debbug:byte;
{F-}

var  deb:text;

procedure run_MZ(pcadr:word); (* MZ xxx Maschinen *)
var  i:word;
    w,z:word;
    ausg:string;
    pc:word;
    k:byte;
    padr:word;

begin
     exit_run:=0;
     aZ80Regs^.pc.W:=pcadr;

     repeat

         if (dasam=1) then
                  begin
                       textcolor(15);
                       w:=0;
                       for i:=0 to 10
                       do
                        begin
                             gotoxy(41,i);
                             if ((aZ80Regs^.pc.W <= $FFF ) and (mL_rom = 1))
                               then
                                   z:=z80_dasm(@rom^[aZ80Regs^.pc.W+w],aZ80Regs^.pc.W+w,ausg)
                               else
                                   z:=z80_dasm(@speicher^[aZ80Regs^.pc.W+w],aZ80Regs^.pc.W+w,ausg);
                             write(hex(aZ80Regs^.pc.W+w,4),':',ausg);
                             inc(w,z);

                        end;
                  end;


         if debug > 0
         then
           begin
             evaloneinstr(1);
             debug_anz;
           end
         else
             EVALinstr(1);

         if lade_flag > 0
         then
            begin
                  case lade_flag
                  of
                     1:tastatur:=[KCTRL]+[Kalt]+[Kf7];
                     2:tastatur:=[KCTRL]+[Kalt]+[Kf11];
                  end;
                  lade_flag:=0;
            end;

         if  ( tastatur <> [] )
            then begin

                    speicher_tasten;

                    if (test_key(kalt) = 1 )
                    then
                        f_key;

                 end
            else
               loesche_tasten;

     until(exit_run = 1);

end;

procedure PRE_RUN_700;    (* Wird gebraucht, damit der EMU  *)
begin                     (* DRAG AND DROB Fhig wird       *)
       evalinstr(1);
       evalinstr(1);
       evalinstr(1);
       evalinstr(1);
end;

procedure run(eing:byte;pcadr:word);
begin
      case eing of
      1:run_MZ(pcadr);         (* SHARP MZ80x *)
      2:begin
             Pre_run_700;
             run_MZ(pcadr);    (* SHARP MZ700 *)
        end;
   end;
end;



(* ------------------------------ *)


procedure save_patch;
begin


            rom^[$45E+0]:=06;   (* QWRI auf PORT1 legen *)
            rom^[$45E+1]:=$F;

            rom^[$45E+2]:=$3E;
            rom^[$45E+3]:=1;


            rom^[$45E+4]:=$D3;
            rom^[$45E+5]:=0;
          

            rom^[$F9E+0]:=$C3;   (* MSG OK *)
            rom^[$F9E+1]:=$A7;
            rom^[$F9E+2]:=$0F;

end;

procedure load_patch;
begin

(* MONITOR einsprung *)

            rom^[$111+0]:=$3E;    (* LD A,1  *)
            rom^[$111+1]:=$1;

            rom^[$111+2]:=$D3;    (* OUT 1,A *)
            rom^[$111+3]:=1;
            rom^[$111+4]:=0;


            rom^[$121]:=0;
            rom^[$122]:=0;
            rom^[$123]:=0;
            rom^[$124]:=0;
            rom^[$125]:=0;



            rom^[$121]:=0;
            rom^[$122]:=0;
            rom^[$123]:=0;
            rom^[$124]:=0;
            rom^[$125]:=0;

            rom^[$509]:=$C3;

            rom^[$601]:=$C9;     (* EDGE *)



            rom^[$4e6+0]:=$3E;    (* LD A,3  *)
            rom^[$4e6+1]:=$3;

            rom^[$4e6+2]:=$D3;    (* OUT 1,A *)
            rom^[$4e6+3]:=1;

            rom^[$4e6+4]:=$C3;    (* JP RTP4 *)
            rom^[$4e6+5]:=$54;
            rom^[$4e6+6]:=$05;
end;

(* --------------------------------------------------------------- *)
procedure lade_MZ_system(auswahl:byte);
begin

            writeln('Load MZlow ROM');


            case auswahl
            of
              1,2:loadrom(akt_dir+'\mz700a.ROM',0,@rom^[0]);
              3:begin
                     loadrom(akt_dir+'\SP1002.ROM',0,@rom^[0]);
                     (*
                     loadrom(akt_dir+'\MZ80K.ROM',0,@rom^[$A92]);
                     *)

                end;
            end;

            (* neue SAVEroutine  ausgabe auf virtuellen Gert *)

            (* save_patch; *)


            load_patch;

             if exist(akt_dir+'\\qdrom.m12') = true
            then
                loadrom(akt_dir+'\qdrom.m12',0,@rom^[$E800-128])
            else
                writeln('qdrom.m12 nicht vorhanden !!');


            (*
            if exist(akt_dir+'\mz800H.ROM') = true
            then
               begin
                      writeln('LOAD MZ800HI ROM');
                      loadrom('mz800H.ROM',0,@rom^[$E000]);
                      rom^[0]:=$c3;
                      rom^[1]:=$00;
                      rom^[2]:=$E8;

                      rom^[$E82c]:=0;
                      rom^[$E82d]:=0;
                      rom^[$E000+$B4C+0]:=06;
                      rom^[$E000+$B4C+1]:=$F;

                      rom^[$E000+$B4C+2]:=$D3;
                      rom^[$E000+$B4C+3]:=1;

                      rom^[$E000+$B4C+4]:=$C3;
                      rom^[$E000+$B4C+5]:=$2E;
                      rom^[$E000+$B4C+6]:=$01;
                      rom^[$E000+$BEC+7]:=$C9;
               end;
             *)

            (*
            loadrom('memory.dmp',0,@speicher^[0]);
             *)
            writeln('ROMPatch OK');


            (* ------------------------------------------------ *)


            init_INTERNAT_FNT;(* Lade Zeichensatz *)
            writeln('MZ_FNT LOAD READY');
end;



procedure converta;
var  i,w:byte;
       c:integer;

type t = record
             ADDR:array[0..5] of char;
             HEXW:array[0..11] of char;
         end;

var test  :file of char;
    test1 :file of byte;
    zeich:char;
    zeile,
    zeile2:string;
    x,e   :byte;

    line:integer;
    auswert:^t;

function lese_zeile:string;
var zeile:string;
begin
           zeile:='';
           repeat
                 read(test,zeich);
                 if zeich  in [#13,#10]
                 then
                 else
                     zeile:=zeile+zeich;
           until (zeich = #13) or (eof(test)) ;
           lese_zeile:=zeile;
end;


begin

     clrscr;

     writeln('Gen-ROM (c) by M.Franzen 1998 ');
     writeln(#13,'Convertiere MZ700a.ASM nach MZ700a.ROM ',#10);
     assign(test, 'MZ700A.ASM');
     assign(test1,'MZ700A.ROM');

     reset(test);
     rewrite(test1);

     for i:=0 to 3
     do lese_zeile;

     repeat

           zeile:=lese_zeile;

           auswert:=@zeile[1];

           write(Zeile);

           for i:=0 to 5
           do
             if (auswert^.hexw[i*2] in ['a'..'f','0','1'..'9']) and not (eof(test))
             then
                 begin
                       val('$'+auswert^.hexw[i*2]+auswert^.hexw[i*2+1],w,c);
                       write(test1,w);
                       write(hex(w,2));
                 end;

             writeln;
     until eof(test);

     close(test);
     close(test1);

     writeln('Fertig  MZ700a.rom raedy');
     writeln(nl,'Bitte starten sie das Programm GEN_FNT und starten den EMU neu.');
     writeln(   'Please run GEN_FNT and restart the EMU.');


end;





const cpr_string:string[40] = ('MZ80K Mode');




procedure start_MZ(auswahl:byte);

var i:word;
const printername :array[1..5] of string[16] = ('MZPRINT.TXT','PRN','LPT1','LPT2','COM2');
      menueitem   :string[80]                  ='PRINTFILE;PRN;LPT1;LPT2;COM2';
begin



      if (exist(akt_dir+'\MZ700a.rom'))
      then
         begin

              (* ------ NORMALER MODUS kein tweake ------ *)

              writeln('INIT CRT');
              init_crt:=init_crt_linear;
              put_patt_8_MZ700:=put_patt_8;

              put_patt_8_MZ1500:=put_patt_15_trans;

              (* ------------------------------------- *)

               writeln('INIT CPU');
               aProcs[1].oGetByteFunc := r_speicherMZ700;
               aProcs[1].oPutByteFunc := w_speicherMz700;
               aProcs[1].oOutByteFunc := MZ700_out;
               aProcs[1].oInByteFunc  := MZ700_in;


               case auswahl
               of
                  2:begin

                         put_patt_8_MZ700:=put_patt_MZ80;
                         aProcs[1].oInByteFunc  := MZ80_in;

                    end;
               end;

              (* ------------------------------------- *)

              CPU_speed:=0;

              assign(mzprint,printername[wpop(28,8,1,'#PRINTER',menueitem)]);   (* PRINTER AUSGABE *)

              rewrite(mzprint);                (* in DATEI *)

              textbackground(blue);

              writeln('INIT KEYB');
              neuer_tast_int;
              loesche_tasten;


              init_ur12;
              writeln('CMOS 32K ');

              tapetik:=0;

              dasam:=0;
              einzelschritt:=0;

              writeln('RESET MZ');



              reset_MZ;

              (* ----- FDD ------ *)

              only_256:=0;{Disketa ma/nema vsecky stopy pouze 256b/sektor (pro BASICove diskety)}
              sektor:=$fe;

              setup720;

              (* -----------------*)
              writeln('LOAD ROMS and PATCH');


              lade_MZ_system(auswahl);

              init_crt;

              init_MZ700Pal;


              run(maschine,0);

              nosound;
              restore_keyb;

              close_ur12;


              close(MZprint);

              init_text;
          end
        else
          begin
            clrscr;
            if (exist(akt_dir+'\MZ700a.ASM'))     (* MZ700a.ASM ROM *)
            then
                converta
            else
            begin
               if (exist(akt_dir+'\MZ700a.ARJ'))     (* MZ700a.ASM ROM *)
                 then
                 begin
                      write('MZ700a.ARJ gefunden: bitte entpacken sie die Datei mit ARJ e mz700a.arj und');
                      writeln('      starten den EMU neu.');
                      writeln('MZ700a.ARJ found: please entpack with arj e mz700a.arj and restart the EMU.');
                 end
               else
                 fehler_MZ700_anzeige;;
            end;
          end;

end;




end.