
unit UMZ_1R12;

interface (* 32 CMOSRAMDISK fr MZ700 *)


uses mzio;

procedure init_Ur12;
procedure close_Ur12;
procedure reset_Ur12;
procedure set_Ur12_seekhi(eing:byte);
procedure set_Ur12_seeklo(eing:byte);


procedure write_Ur12(eing:byte);

function  read_Ur12:byte;


implementation

type ramd = array[0..1024*32] of byte;

const Ur12_size = 1024*32+1;

var CMOS : ^ramd;

    Ur12_seek:word;

(* ----------- MZ 1R12 CMOS in ----

          $F8:reset_Ur12;
          $F9:x:=read_Ur12;

(* -------- MZ 1R12 CMOS  out ------

          $F8:set_Ur12_seekhi(eing);
          $F9:set_Ur12_seeklo(eing);
          $FA:write_Ur12(eing);


   ------------------------------*)

procedure reset_Ur12;
begin
     Ur12_seek:=0;
end;

procedure save_Ur12_cmos(name:string);
var datei:file;
    bytes:word;
begin
     assign(datei,name);
     {$i-}
     rewrite(datei,1);
     {$i+}
     blockwrite(datei,cmos^[0],Ur12_size,bytes);
     close(datei);
     if bytes <> ur12_size then writeln(#7,'fehler beim sichern von 1r12_cmos',#7);
end;

procedure load_Ur12_cmos(name:string);
var datei:file;
    bytes:word;
begin
     assign(datei,name);
     {$i-}
     reset(datei,1);
     {$i+}
     if ioresult = 0
        then
           begin
                blockread(datei,cmos^[0],Ur12_size,bytes);
                close(datei);
                writeln('CMOS geladen');
           end;
end;


procedure init_Ur12;
begin
      getmem(CMOS,1024*32+1);
      load_ur12_cmos(akt_dir+'\cmos_1R12.R12');
end;

procedure set_Ur12_seekhi(eing:byte);
begin
      Ur12_seek:=eing shl 8 + Ur12_seek and $FF;
      Ur12_seek:=Ur12_seek mod Ur12_size;
end;


procedure set_Ur12_seeklo(eing:byte);
begin
      Ur12_seek:=eing + Ur12_seek and $FF00;
      Ur12_seek:=Ur12_seek mod Ur12_size;
end;

procedure write_Ur12(eing:byte);
begin
     cmos^[Ur12_seek]:=eing;
     inc(Ur12_seek);
     Ur12_seek:=Ur12_seek mod Ur12_size;
end;

function read_Ur12:byte;
begin
     read_Ur12:=cmos^[Ur12_seek];
     inc(Ur12_seek);
     Ur12_seek:=Ur12_seek mod Ur12_size;
end;


procedure close_Ur12;
begin
     save_ur12_cmos(akt_dir+'\cmos_1R12.R12');
     freemem(cmos,1024*32+1);
end;


end.


