unit uspectr;

interface


uses bas,crt,dos,kbd,MZio,Uz80,z80das,fenst;



procedure spectrum_out(adr,eing:word);
function  spectrum_in(eing:word):byte;
function  spectrum_read(addr:word):byte;
procedure spectrum_write(addr,eing:word);
procedure spectrum_Int;
procedure start_spectrum;



implementation

const spectr_to_VGA:array[0..15] of byte = (0,1,4 ,5 ,2 ,lightblue,14,15 ,
                                              9,12,13,10,6,14,15,15);


procedure spectrum_out(adr,eing:word);
begin
      if adr  and $FF  = 254
      then
         if eing and 16 <> 0
                then
                    sound(60000)
                else
                    nosound;

end;



function spectrum_in(eing:word):byte;
var z:word;
    x:byte;
   te:word;
begin
     x:=255;


     case eing
     of
       65278:
                 x:=(test_key(Klshift) shl 0 or test_key(kz) shl 1  or test_key(Kx) shl 2 or
                 test_key(Kc) shl 3 or test_key(Kv) shl 4 ) xor 255;

       65022:
                 x:=(test_key(Ka) shl 0 or test_key(ks) shl 1  or test_key(Kd) shl 2 or
                 test_key(Kf) shl 3 or test_key(Kg) shl 4 ) xor 255;
       64510:
                 x:=(test_key(Kq) shl 0 or test_key(kw) shl 1  or test_key(Ke) shl 2 or
                 test_key(Kr) shl 3 or test_key(Kt) shl 4 ) xor 255;

       63486:
                 x:=(test_key(K1) shl 0 or test_key(k2) shl 1  or test_key(K3) shl 2 or
                 test_key(K4) shl 3 or test_key(K5) shl 4 ) xor 255;
       61438:
                 x:=(test_key(K0) shl 0 or test_key(k9) shl 1  or test_key(K8) shl 2 or
                 test_key(K7) shl 3 or test_key(K6) shl 4 ) xor 255;
       57342:
                 x:=(test_key(Kp) shl 0 or test_key(ko) shl 1  or test_key(Ki) shl 2 or
                 test_key(Ku) shl 3 or test_key(Ky) shl 4 ) xor 255;
       49150:
                 x:=(test_key(Kenter) shl 0 or test_key(kl) shl 1  or test_key(Kk) shl 2 or
                 test_key(Kj) shl 3 or test_key(Kh) shl 4 ) xor 255;
       32766:
                 x:=(test_key(Kspace) shl 0 or (test_key(krshift) shl 1)  or (test_key(Km) shl 2) or
                 test_key(Kn) shl 3 or test_key(Kb) shl 4 ) xor 255;
     end;

     spectrum_in:=x;

       if (eing and 1) <> 0
     then
         spectrum_in:=0;

     if eing and $ff = 31
     then
        begin
             spectrum_in:=test_key(Krt)        or test_key(klf) shl 1 or
                          test_key(Kdn) shl 2  or test_key(Kup) shl 3 or
                          test_key(Kctrl) shl 4;
        end;


   
end;



procedure spectrum_screen(Vaddr:word);  (* Farb_ROUTINE *)

(* Addr bei $4000 *)

var  adr: integer;
     x,y,s:word;
     a,farbe,attr,paper,ink:byte;
     eing:byte;

     s_seg,s_ofs:word;

begin

     eing:=speicher^[vaddr];
     s_seg:=seg(speicher^[vaddr]);
     s_ofs:=ofs(speicher^[Vaddr]);

     asm

         mov cx,Vaddr;  (* Line of crt *)


         mov ax,cx;
         shr ax,$08
         and ax,$07
         mov bx,ax;

         mov ax,cx;
         shr ax,$02
         and ax,$38
         or bx,ax;

         mov ax,cx;
         shr ax,$05
         and ax,$C0
         or bx,ax;

         mov y,bx;      (* Y *)

         mov ax ,cx;    (* COL of CRT *)
         and ax ,$1F;
         mov x,ax       (* X *)

     end;


     Attr := speicher^[$5800+x+(y shr 3) shl 5];
     Paper :=spectr_to_vga[((Attr shr 3) and $0F) mod 8];
     Ink :=spectr_to_VGA[(Attr and 7) or ((Attr shr 3) and 8) mod 8];

     if (attr shr 7) and 1 <> 0
       then
         begin
           s:=ink; ink:=paper; paper:=s;
         end;


     asm

         mov ax,y;    (* bei anderer Umgebung die Register sichern *)
         mov bx,x;    (* und dann Werte zuweisen *)
         shl bx,3;    (* X * 8 *)
         add bx,40;

         mov cl,ink;
         mov ch,paper;
         mov dl,eing;

         push cx;     (* FARBE AUF DEN STAPEL *)
         push dx;     (* WERT *)

         sub bx,1;
         mov cx,20;   (* 320 Bildpunkte - 20  256 Farben und lineare Adressen *)
         mul cx;      (* 640            - 40     *)
         mov cx,$A000;(* START VGA *)
         add ax,cx    (* VERSCHIBE UM Y-ZEILEN   *)
         mov es,ax    (* bei mehr als 64 K ntig *)

         pop dx;
         pop cx;      (* FARBE VOM STAPEL ZURCK *)
                      (* 8 - BIT        *)
         mov dh,1;    (* VERGLEICH      *)

         @START:      (* HIER DIE 8 BIT AUSGABE  *)

             test dl,dh;
             mov es:[bx],ch;
             jnz @bit_0;

             jp @next;

             @BIT_0:
                        mov es:[bx],cl;
             @next:

             dec bx;    (* X um 1 herunterzhlen *)
             shl dh,1;
             cmp dh,0;

         jnz @start;

     end;

end;





function  spectrum_read(addr:word):byte;
begin
      spectrum_read:=speicher^[addr];
end;

procedure refresh_spec_crt;
var i:word;

begin

      for i:=$4000 to $5800
      do
        spectrum_screen(i);
end;




procedure spectrum_write(addr,eing:word);
begin

         if addr >= $4000
                then
                    speicher^[addr]:=eing;




         if (addr >= $4000)  and (addr <=$57ff)
                then
                    spectrum_screen(addr);


end;

(* ------------------------------ *)


procedure SpectrumLoadCart(name:string);
var
  oSnap: File;
  I,l: word;
  nByte: Byte;

function GetByte(var F: File): Byte;
var
  I: Byte;
begin
  blockRead(F, i, 1);
  GetByte := I;
end;

function Get2(var F: File): Word;
var
  l, h: Word;
begin
  l := GetByte(F);
  h := GetByte(F);
  Get2 := (h shl 8) or l;
end;

begin
    Assign(oSnap,Name);
    Reset(oSnap,1);

    aZ80Regs^.I := getbyte(oSnap);                  { 00 }
    aZ80Regs^.HL1.w := get2(oSnap);                 { 01 }
    aZ80Regs^.DE1.w := get2(oSnap);                 { 03 }
    aZ80Regs^.BC1.w := get2(oSnap);                 { 05 }
    aZ80Regs^.AF1.w := get2(oSnap);                 { 07 }
    aZ80Regs^.HL.w := get2(oSnap);                  { 09 }
    aZ80Regs^.DE.w := get2(oSnap);                  { 0B }
    aZ80Regs^.BC.w := get2(oSnap);                  { 0D }
    aZ80Regs^.IY.w := get2(oSnap);                  { 0F }
    aZ80Regs^.IX.w := get2(oSnap);                  { 11 }
    I := getbyte(oSnap);
    if (I and $04)<>0 then
      aZ80Regs^.IFF1 := 1
    else
      aZ80Regs^.IFF1 := 0;
    aZ80Regs^.IFF2 := aZ80Regs^.IFF1;

    aZ80Regs^.R := getbyte(oSnap);                  { 14 }
    aZ80Regs^.AF.l := getbyte(oSnap);               { 15 }
    aZ80Regs^.AF.h := getbyte(oSnap);               { 16 }
    aZ80Regs^.SP.w := get2(oSnap);                  { 17 }
    aProcs[1].nIM  := GetByte(oSnap);               { 19 }
    if aProcs[1].nIM<>0 then Inc(aProcs[1].nIM); { nIM=1 is IM undocumented!}
    I := GetByte(oSnap);                            { 20 }

    BlockRead(osnap,speicher^[$4000],$FFFF-$4000+1);

    aZ80Regs^.PC.w := 256*spectrum_read(aZ80Regs^.SP.w+1)+spectrum_read(aZ80Regs^.SP.w);
    Inc(aZ80Regs^.SP.w, 2);
    Close(oSnap);
    refresh_spec_crt;
end;

(* ------------------------------ *)


procedure test(eing:word);
begin
      writeln(eing);

end;

var spe_int_tik:byte;
procedure spectrum_Int;
var i:word;
begin

 aProcs[1].nPendingIRQ := $000000FF;

 inc(spe_int_tik);

 if spe_int_tik mod 22 = 0
 then

    for i:=$4000 to $5800
      do
        spectrum_screen(i);

end;


procedure Pre_init;

begin
    aZ80Regs := @aProcs;
    FillChar(aProcs, SizeOf(aProcs), 0);
    aProcs[1].nIM := 0;
    aProcs[1].nHalted := 0;
    aZ80Regs^.SP.W := $FF00;
    aZ80Regs^.PC.W := $0000;

end;

procedure load_spec_system;
 begin

             Pre_init;

             loadrom(akt_dir+'\spectrum.rom',0,@speicher^[0]);

             init_mode_13;
             aProcs[1].oGetByteFunc := spectrum_read;
             aProcs[1].oPutByteFunc := spectrum_write;
             aProcs[1].oOutByteFunc := spectrum_out;
             aProcs[1].oInByteFunc  := spectrum_in;
             aProcs[1].oInterruptFunc := spectrum_INT;
             aProcs[1].oMemory := speicher;

             aProcs[1].nNMIInt := $66;

             aZ80Regs^.nMaxROM := 16000;
             aZ80Regs^.nMaxRAM := $FFFF;
             aZ80Regs^.nTickMach:=69888;

       end;



procedure select_SNAP(ext:string);
begin
     init_text;
     restore_keyb;
     dateiname:=windir('','*.'+ext);
     neuer_tast_int;
     init_mode_13;
     directvideo:=false;
     loesche_tasten;
end;




procedure start_spectrum;
var i:word;
begin
               writeln('INIT KEYB');
               neuer_tast_int;
               loesche_tasten;

               load_spec_system;
               exit_run:=0;
               repeat
                    Evalinstr(1);

                    if test_key(kalt) = 1
                    then
                       begin

                           if test_key(kF1) = 1 then
                             begin

                               restore_keyb;
                               textmode(co80);

                               help('spec.HLP');

                               neuer_tast_int;

                               init_mode_13;

                               refresh_spec_crt;

                               directvideo:=false;
                               loesche_tasten;

                             end;
                            if test_key(KF11) = 1
                            then
                              begin

                                   select_snap('sna');

                                   refresh_spec_crt;
                                   
                                   if dateiname <> 'ESCAPE'
                                   then
                                       SpectrumLoadCart(dateiname);

                                   tastatur:=[];
                              end;

                            if test_key(KF8) = 1
                               then
                                   aZ80Regs^.PC.W := $0000;
                       end;


               until kesc in tastatur;;

               restore_keyb;
               init_text;


end;





begin

end.x