unit uZX81;

interface


uses bas,crt,dos,kbd,MZio,Uz80,z80das,fenst;



procedure ZX81_out(adr,eing:word);
function  ZX81_in(eing:word):byte;
function  ZX81_read(addr:word):byte;
procedure ZX81_write(addr,eing:word);
procedure ZX81_Int;
procedure start_ZX81;



implementation

const VGG_ROM :word = $1E00;


procedure ZX81SAVECHART(name:string);

var i:word;
    k:file of byte;

begin
      assign(k,name+'.P');
      rewrite(k);

      for i:=$4009 to r_word(@speicher^[16406])+1
      do
        write(k,speicher^[i]);

      close(k);

end;


procedure ZX81LoadCart(name:string);
var
  oSnap: File of byte;
  I,l: word;
  nByte: Byte;

begin

    Assign(oSnap,Name);
    Reset(oSnap);


    i:=$4009;

    while not eof(oSnap)
    do
      begin
           Read(osnap,speicher^[i]);
           inc(i);
      end;


    Close(oSnap);

end;

(* ------------------------------ *)




procedure select_P(ext:string);
begin
     init_text;
     restore_keyb;
     dateiname:=windir('','*.'+ext);
     neuer_tast_int;
     init_mode_13;
     directvideo:=false;
     loesche_tasten;
end;

procedure refresh_ZX_crt;forward;

procedure ZX81_out(adr,eing:word);
begin
      if adr  and $FF  = 254
      then
         if eing and 16 <> 0
                then
                    sound(20)
                else
                    nosound;

      if adr and $FF = 0
      then
         begin

                                   select_p('p;*.81');

                                   refresh_ZX_crt;
                                   
                                   if dateiname <> 'ESCAPE'
                                   then
                                       ZX81LoadCart(dateiname);

                                   tastatur:=[];
         end;

end;



function ZX81_in(eing:word):byte;
var z:word;
    x:byte;
   te:word;
begin
     x:=255;


     case eing
     of
       65278:
                 x:=(test_key(Klshift) shl 0 or test_key(kz) shl 1  or test_key(Kx) shl 2 or
                 test_key(Kc) shl 3 or test_key(Kv) shl 4 ) xor 255;

       65022:
                 x:=(test_key(Ka) shl 0 or test_key(ks) shl 1  or test_key(Kd) shl 2 or
                 test_key(Kf) shl 3 or test_key(Kg) shl 4 ) xor 255;
       64510:
                 x:=(test_key(Kq) shl 0 or test_key(kw) shl 1  or test_key(Ke) shl 2 or
                 test_key(Kr) shl 3 or test_key(Kt) shl 4 ) xor 255;

       63486:
                 x:=(test_key(K1) shl 0 or test_key(k2) shl 1  or test_key(K3) shl 2 or
                 test_key(K4) shl 3 or (test_key(K5) or test_key(klf)) shl 4 ) xor 255;
       61438:
                 x:=(test_key(K0) shl 0 or test_key(k9) shl 1  or (test_key(K8) or test_key(krt)) shl 2 or
                 (test_key(K7) or test_key(Kup)) shl 3 or (test_key(K6) or test_key(Kdn)) shl 4 ) xor 255;
       57342:
                 x:=(test_key(Kp) shl 0 or test_key(ko) shl 1  or test_key(Ki) shl 2 or
                 test_key(Ku) shl 3 or test_key(Ky) shl 4 ) xor 255;
       49150:
                 x:=(test_key(Kenter) shl 0 or test_key(kl) shl 1  or test_key(Kk) shl 2 or
                 test_key(Kj) shl 3 or test_key(Kh) shl 4 ) xor 255;
       32766:
                 x:=(test_key(Kspace) shl 0 or (test_key(krshift) shl 1)  or (test_key(Km) shl 2) or
                 test_key(Kn) shl 3 or test_key(Kb) shl 4 ) xor 255;
     end;

     ZX81_in:=x;



       if (eing and 1) <> 0
     then
         ZX81_in:=0;

     if eing and $ff = 31
     then
        begin
             ZX81_in:=test_key(Krt) or test_key(klf) shl 1 or
                          test_key(Kdn) shl 2  or test_key(Kup) shl 3 or
                          test_key(Kctrl) shl 4;
        end;



   
end;



function  ZX81_read(addr:word):byte;
begin
      ZX81_read:=speicher^[addr];
end;





procedure zx81_screen(ad,i:word);

var
    k,x,y:byte;
    Zeichen_matrix:pointer;
    v,h:byte;

begin
             v:=0; h:=15;
             y:=(i-ad) div 33;
             x:=(1+i-ad) - y*33;
             k:=speicher^[i];
             if (k > 135) and (k < 192)
             then
                begin
                      v:=yellow; h:=blue;
                      k:=k and 127;
                end;

             zeichen_matrix:= @speicher^[(k shl 3)+VGG_ROM];

             if x > 1
             then
                 put_patt_ZX(24+x shl 3,4 + y shl 3,v,h, seg(zeichen_matrix^),ofs(zeichen_matrix^));
end;



procedure refresh_ZX_crt;
var ad,i:word;

begin
       ad:=r_word(@speicher^[$400c]);

       for i:=ad to ad+792 (* 33*24 *)
          do
            zx81_screen(ad,i);

end;




procedure ZX81_write(addr,eing:word);
var ad:word;
begin

         if addr >= $4000
                then
                    speicher^[addr]:=eing;

          ad:=r_word(@speicher^[$400c]);

          if  (addr >= ad ) and  (addr <= ad+792) (* 33*24 *)
          then
            zx81_screen(ad,addr);
end;

(* ------------------------------ *)





procedure ZX81_Int;
var i,ad:word;
    k,x,y:byte;



begin


(* aProcs[1].nPendingIRQ := $000000FF;
 aProcs[1].nPendingIRQ := $000000D7;*)  (* RST 10H       *)


end;


procedure Pre_init;

begin
    aZ80Regs := @aProcs;
    FillChar(aProcs, SizeOf(aProcs), 0);
    aProcs[1].nIM := 0;
    aProcs[1].nHalted := 0;
    aZ80Regs^.SP.W := $FF00;
    aZ80Regs^.PC.W := $0000;

end;

procedure load_ZX81_system;
 begin

             fillchar(speicher^[0],65535,$ff);
             Pre_init;

             loadrom(akt_dir+'\ZX81.rom',0,@speicher^[0]);

             
(* a 'force F/0' at 66h; ok, as we simulate NMI effects by other means *)
Speicher^[$66]:=$cf; Speicher^[$67]:=$0e;

(* patch save routine *)
speicher^[$2fc]:=$0; Speicher^[$2fd]:=$0;
Speicher^[$2fe]:=$c3; Speicher^[$2ff]:=$07; Speicher^[$300]:=$02;

(* patch load routine *)

Speicher^[$347]:=$eb;
Speicher^[$348]:=$d3; Speicher^[$349]:=$0;
Speicher^[$34a]:=$c3; Speicher^[$34b]:=$07; Speicher^[$34c]:=$02;

(* make fast/slow more traceable (directly modify bit 7 rather than
 * bit 6 of CDFLAGS)
 *)

Speicher^[$f29]:=$be;
Speicher^[$f2e]:=$fe;

(* do 'out (0),a' when waiting for input (for fast mode display check) *)
(*
Speicher^[$4ca]:=$d3; Speicher^[$4cb]:=0
Speicher^[$4cc]:=$cb; Speicher^[$4cd]:=$46;
Speicher^[$4ce]:=$28; Speicher^[$4cf]:=$fc;
Speicher^[$4d0]:=$d3; Speicher^[$4d1]:=???
Speicher^[$4d2]:=0;	(* nop, as filler *)

(* skip some more weird fast mode stuff *)
Speicher^[$2ec]:=$c9;

(* nop out ld (04034h),hl *)
Speicher^[$23a]:=0; Speicher^[$23a]:=0; Speicher^[$23a]:=0;

(* nop out call to 207h *)
Speicher^[$f41]:=0; Speicher^[$f42]:=0; Speicher^[$f43]:=0;




             init_mode_13;

             aProcs[1].oGetByteFunc := ZX81_read;
             aProcs[1].oPutByteFunc := ZX81_write;
             aProcs[1].oOutByteFunc := ZX81_out;
             aProcs[1].oInByteFunc  := ZX81_in;
             aProcs[1].oInterruptFunc := ZX81_INT;
             aProcs[1].oMemory := speicher;


             aProcs[1].nNMIInt := $66;

             aZ80Regs^.nMaxROM := 16000;
             aZ80Regs^.nMaxRAM := $FFFF;
             aZ80Regs^.nTickMach:=69888;

       end;








procedure start_ZX81;
var i:word;
begin
               writeln('INIT KEYB');
               neuer_tast_int;
               loesche_tasten;



               load_ZX81_system;

               exit_run:=0;
               repeat
                    Evalinstr(1);

                    if test_key(kalt) = 1
                    then
                       begin

                           if test_key(kF1) = 1 then
                             begin

                               restore_keyb;
                               textmode(co80);

                               help('ZX81.HLP');

                               neuer_tast_int;

                               init_mode_13;

                               refresh_ZX_crt;

                               directvideo:=false;
                               loesche_tasten;

                             end;

                            if test_key(KF11) = 1
                            then
                              begin

                                   select_p('p');

                                   refresh_ZX_crt;
                                   
                                   if dateiname <> 'ESCAPE'
                                   then
                                       ZX81LoadCart(dateiname);

                                   tastatur:=[];
                              end;

                            if test_key(KF8) = 1
                               then
                                   aZ80Regs^.PC.W := $0000;

                            if test_Key(Kf9) = 1
                                then
                                   ZX81SAVECHART('test');
                       end;


               until kesc in tastatur;;

               restore_keyb;
               init_text;


end;





begin

end.